#!/usr/bin/python3
#! This python v3 script runs/executes the Grafcet data that is sent from the software Grafcet-Studio over MQTT. See www.mhj-wiki.de
#
#
#
#
import time
import math   
import struct
import datetime

import array
import sys
import uuid
from ctypes import Structure,c_bool, c_int,c_ubyte,c_uint16,c_uint32,c_int16,c_int32,c_uint32,c_float,Union,c_long
import paho.mqtt.client as mqtt
from pathlib import Path
import os

from threading import Timer
#

#
#
#


class lIl101DFlIl():
    
    def __init__(self, lIlFFFFlIl=None):    
        self.buffer=bytearray()
        if (lIlFFFFlIl!=None):
            for v in lIlFFFFlIl:
                self.buffer.append(v)
        
    def lIl10000lIl(self):    
        return self.buffer.__len__()

    def lIl10001lIl(self,lIl10002lIl):    
        self.buffer=bytearray()
        for v in range(lIl10002lIl):
            self.buffer.append(0)
    def lIl10003lIl(self):    
        for v in range(self.buffer.__len__()):
            self.buffer[v]=0

    def lIl10004lIl(self, lIl10005lIl):    
        self.buffer.append(lIl10005lIl)

    def lIl10006lIl(self, lIl10007lIl): 
        lIl10008lIl=struct.pack("=h", c_int16(lIl10007lIl))
        self.buffer.append(lIl10008lIl[0])
        self.buffer.append(lIl10008lIl[1])
    def lIl10009lIl(self, lIl1000AlIl):    
        lIl1000BlIl=struct.pack("=H", int(lIl1000AlIl))
        self.buffer.append(lIl1000BlIl[0])
        self.buffer.append(lIl1000BlIl[1])
    def lIl1000ClIl(self, lIl1000DlIl):    
        lIl1000ElIl=struct.pack("=f", c_float(lIl1000DlIl))
        self.buffer.append(lIl1000ElIl[0])
        self.buffer.append(lIl1000ElIl[1])
        self.buffer.append(lIl1000ElIl[2])
        self.buffer.append(lIl1000ElIl[3])
    def lIl1000FlIl(self, lIl10010lIl, lIl10011lIl, lIl10012lIl):
        lIl10010lIl.clear()
        for t in range(lIl10012lIl):
            lIl10010lIl.append(self.buffer[lIl10011lIl+t])
            
    def lIl10013lIl(self, lIl10014lIl):    
        for b in lIl10014lIl:
            self.buffer.append(b)
    def lIl10015lIl(self):
        return self.buffer
    def lIl10016lIl(self,lIl10017lIl, lIl10018lIl):
        return (self.buffer[lIl10017lIl] & (1 << lIl10018lIl)) != 0
    def lIl10019lIl(self,lIl1001AlIl):
        return struct.unpack('=f',self.buffer[lIl1001AlIl:lIl1001AlIl+4])[0]
    def lIl1001BlIl(self,lIl1001ClIl):
        return struct.unpack('=h',self.buffer[lIl1001ClIl:lIl1001ClIl+2])[0]
    def lIl1001DlIl(self,lIl1001ElIl):
        return struct.unpack('=i',self.buffer[lIl1001ElIl:lIl1001ElIl+4])[0] 
    def lIl1001FlIl(self,lIl10020lIl):
        return struct.unpack('=H',self.buffer[lIl10020lIl:lIl10020lIl+2])[0] 
    def lIl10021lIl(self,lIl10022lIl):
        return struct.unpack('>H',self.buffer[lIl10022lIl:lIl10022lIl+2])[0]
    def lIl10023lIl(self,lIl10024lIl):
        return struct.unpack('>I',self.buffer[lIl10024lIl:lIl10024lIl+4])[0]    
    def lIl10025lIl(self,lIl10026lIl):
        return struct.unpack('=I',self.buffer[lIl10026lIl:lIl10026lIl+4])[0]    
    def lIl10027lIl(self,lIl10028lIl):
        return self.buffer[lIl10028lIl]
    def lIl10029lIl(self, lIl1002AlIl, lIl1002BlIl):
        return self.buffer[lIl1002AlIl:lIl1002AlIl+lIl1002BlIl]
    def lIl1002ClIl(self,lIl1002DlIl,lIl1002ElIl):
        lIl1002FlIl=struct.pack("=I", lIl1002ElIl)
        self.buffer[lIl1002DlIl+0]=lIl1002FlIl[0]
        self.buffer[lIl1002DlIl+1]=lIl1002FlIl[1]
        self.buffer[lIl1002DlIl+2]=lIl1002FlIl[2]
        self.buffer[lIl1002DlIl+3]=lIl1002FlIl[3]
    def lIl10030lIl(self,lIl10031lIl,lIl10032lIl):
        lIl10033lIl=c_uint16(lIl10032lIl) 
        lIl10034lIl=struct.pack("=H", lIl10033lIl.value) 
        self.buffer[lIl10031lIl+0]=lIl10034lIl[0]
        self.buffer[lIl10031lIl+1]=lIl10034lIl[1]
    def lIl10035lIl(self,lIl10036lIl,lIl10037lIl):
        self.buffer[lIl10036lIl]=lIl10037lIl
    def lIl10038lIl(self, lIl10039lIl, lIl1003AlIl,lIl1003BlIl):
        lIl1003ClIl = 1 << lIl1003AlIl
        if lIl1003BlIl:
            self.buffer[lIl10039lIl] |= lIl1003ClIl 
        else:
            lIl1003ClIl=~lIl1003ClIl 
            self.buffer[lIl10039lIl] &= lIl1003ClIl 
    def lIl1003DlIl(self,lIl1003ElIl, lIl1003FlIl):
        for b in range(lIl1003FlIl):
            self.buffer[b]=lIl1003ElIl.buffer[b]
            

#
class lIl101E0lIl(object):
    def __init__(self, lIl10040lIl, lIl10041lIl, *lIl10042lIl, **lIl10043lIl):
        self._timer     = None
        self.interval   = lIl10040lIl
        self.functionIsBusy = False
        self.function   = lIl10041lIl
        self.args       = lIl10042lIl
        self.kwargs     = lIl10043lIl
        self.is_running = False
        self.lIl10045lIl()

    def lIl10044lIl(self):
        self.is_running = False
        self.lIl10045lIl()
        if self.functionIsBusy: return
        self.functionIsBusy=True
        self.function(*self.args, **self.kwargs)
        self.functionIsBusy=False

    def lIl10045lIl(self):
        if not self.is_running:
            self._timer = Timer(self.interval, self.lIl10044lIl)
            self._timer.lIl10045lIl()
            self.is_running = True

    def lIl10046lIl(self):
        self._timer.cancel()
        self.is_running = False


#
class BYTE32(Structure): 
    _fields_ = [("UINT8_0", c_ubyte), ("UINT8_1", c_ubyte),("UINT8_2", c_ubyte),("UINT8_3", c_ubyte)]

class WORD32(Structure):
    _fields_ = [("UINT16_0", c_uint16), ("UINT16_1", c_uint16)]

class INT32(Structure):
    _fields_ = [("INT16_0", c_int16), ("INT16_1", c_int16)]

class Any32(Union):
    _fields_ = [("UINT32", c_uint32),("INT32", c_int32), ("FLOAT_0", c_float), ("i", INT32), ("w", WORD32), ("b", BYTE32)]
#

#
class lIl101E1lIl:
    lIl101EBlIl = 20
    lIl101EClIl = 18
    lIl101EDlIl = 20000
    lIl101EElIl = 100
    lIl101EFlIl = 100
    lIl101F0lIl = 100
    lIl101F1lIl = 100
    lIl101F2lIl = 100
    lIl101F3lIl = 100
    lIl101F4lIl = 255 
    lIl101F5lIl = 255 
    lIl101F6lIl = 255 
    
    lIl101F7lIl = 1
    lIl101F8lIl = 3
    lIl101F9lIl = 2
    lIl101FAlIl = 4
    lIl101FBlIl = 5
    lIl101FClIl = 0
    lIl101FDlIl = 101
    lIl101FElIl = 103

    lIl101FFlIl = 2000
    lIl10200lIl = 5000

    lIl10201lIl = 0
    lIl10202lIl = 1
    lIl10203lIl = 2
    lIl10204lIl = 3
    lIl10205lIl = 4
    lIl10206lIl = 5
    lIl10207lIl = 6
    lIl10208lIl = 7
    lIl10209lIl = 8
    lIl1020AlIl = 9
    lIl1020BlIl = 10
    lIl1020ClIl = 11
    lIl1020DlIl = 12
    lIl1020ElIl = 13
    lIl1020FlIl = 14
    lIl10210lIl = 15
    lIl10211lIl = 16
    lIl10212lIl = 17
    lIl10213lIl = 18
    lIl10214lIl = 19
    lIl10215lIl = 20
    lIl10216lIl = 21
    lIl10217lIl = 22
    lIl10218lIl = 23
    lIl10219lIl = 24
    lIl1021AlIl = 25
    lIl1021BlIl = 26

    lIl1021ClIl = 27
    lIl1021DlIl = 28
    lIl1021ElIl = 29
    lIl1021FlIl = 30
    lIl10220lIl = 36 
    lIl10221lIl = 37 
    lIl10222lIl = 50 
    lIl10223lIl = 51 
    lIl10224lIl = 52 
    lIl10225lIl = 53 
    lIl10226lIl = 54
    lIl10227lIl = 55
    lIl10228lIl = 56
    lIl10229lIl = 57
    lIl1022AlIl = 58
    lIl1022BlIl = 59
    lIl1022ClIl = 60
    lIl1022DlIl = 61
    lIl1022ElIl = 62
    lIl1022FlIl = 63
    lIl10230lIl = 64
    lIl10231lIl = 65
    lIl10232lIl = 66
    lIl10233lIl = 67
    lIl10234lIl = 68
    lIl10235lIl = 69
    lIl10236lIl = 70
    lIl10237lIl = 71
    lIl10238lIl = 72
    lIl10239lIl = 73
    lIl1023AlIl = 74
    lIl1023BlIl = 75
    lIl1023ClIl = 76
    lIl1023DlIl = 77
    lIl1023ElIl = 78
    lIl1023FlIl = 79
    lIl10240lIl = 80
    lIl10241lIl = 81
    lIl10242lIl = 82
    lIl10243lIl = 83
    lIl10244lIl = 84
    lIl10245lIl = 85
    lIl10246lIl = 86
    lIl10247lIl = 87
    lIl10248lIl = 88
    lIl10249lIl = 89
    lIl1024AlIl = 90
    lIl1024BlIl = 91
    lIl1024ClIl = 92
    lIl1024DlIl = 93
    lIl1024ElIl = 94
    lIl1024FlIl = 95
    lIl10250lIl = 96
    lIl10251lIl = 97
    lIl10252lIl = 98
    lIl10253lIl = 99
    lIl10254lIl = 100
    lIl10255lIl = 101
    lIl10256lIl = 102
    lIl10257lIl = 103
    lIl10258lIl = 104
    lIl10259lIl = 105
    lIl1025AlIl = 106
    lIl1025BlIl = 107
    lIl1025ClIl = 108
    lIl1025DlIl = 109
    lIl1025ElIl = 110
    lIl1025FlIl = 111
    lIl10260lIl = 112
    lIl10261lIl = 113
    lIl10262lIl = 114
    lIl10263lIl = 115
    lIl10264lIl = 116
    lIl10265lIl = 117
    lIl10266lIl = 118
    lIl10267lIl = 119
    lIl10268lIl = 120
    lIl10269lIl = 121
    lIl1026AlIl = 122
    lIl1026BlIl = 123
    lIl1026ClIl = 124



class lIl101E2lIl:
    def __init__(self):
        self.lIl1026DlIl=0
        self.lIl1026ElIl=0
        self.lIl1026FlIl=0
        self.lIl10270lIl=0
        self.lIl10271lIl=0
        self.lIl10272lIl=10
        self.lIl10273lIl=20
        self.lIl10274lIl=30
        self.lIl10275lIl=40
        self.lIl10276lIl=50
        self.lIl10277lIl=100
        self.lIl10278lIl=0
        self.lIl10279lIl=40
        self.lIl1027AlIl=10
        self.lIl1027BlIl=10
        self.lIl1027ClIl=10
        self.lIl1027DlIl=10
        self.lIl1027ElIl=10
        self.lIl1027FlIl=10  
        self.lIl10280lIl=lIl101E3lIl()

    def lIl10047lIl(self, lIl10048lIl):
        lIl10049lIl=0
        lIl1004AlIl=lIl10048lIl.__len__()
        self.lIl1026DlIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl1026ElIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl1026FlIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10270lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        
        self.lIl10271lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10272lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10273lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10274lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10275lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10276lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10277lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2

        self.lIl10279lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl1027AlIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl1027BlIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl1027ClIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl1027DlIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl1027ElIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl1027FlIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10278lIl=self.lIl10279lIl+self.lIl1027AlIl+self.lIl1027BlIl+self.lIl1027ClIl+self.lIl1027DlIl+self.lIl1027ElIl+self.lIl1027FlIl
        if lIl1004AlIl<lIl10049lIl+20:
            return
        self.lIl10280lIl.lIl10281lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl10282lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl10283lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl10284lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl10285lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl10286lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl10287lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl10288lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl10289lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl1028AlIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl1028BlIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl1028ClIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl1028DlIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl1028ElIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl1028FlIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl10290lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl10291lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
        self.lIl10280lIl.lIl10292lIl=struct.unpack('=H',lIl10048lIl[lIl10049lIl:lIl10049lIl+2])[0]; lIl10049lIl+=2
                              
#
class lIl101E3lIl:
    def __init__(self):
        self.lIl10281lIl=0
        self.lIl10282lIl=0
        self.lIl10283lIl=0
        self.lIl10284lIl=0
        self.lIl10285lIl=0
        self.lIl10286lIl=0
        self.lIl10287lIl=0
        self.lIl10288lIl=0
        self.lIl10289lIl=0
        self.lIl1028AlIl=0
        self.lIl1028BlIl=0
        self.lIl1028ClIl=0
        self.lIl1028DlIl=0
        self.lIl1028ElIl=0
        self.lIl1028FlIl=0
        self.lIl10290lIl=0
        self.lIl10291lIl=0
        self.lIl10292lIl=0
        

#
class lIl101E4lIl:
    def __init__(self):
        self.lIl10293lIl = False
        self.lIl10294lIl = False
        self.lIl10295lIl = False 
        self.lIl10296lIl = False 
        self.lIl10297lIl = False 
        self.lIl10298lIl = False 
        self.lIl10299lIl = False 
        self.lIl1029AlIl = False 
        self.lIl1029BlIl = False 
        self.lIl1029ClIl = False 
        self.lIl1029DlIl = False 
        self.lIl1029ElIl = 0 
        self.lIl1029FlIl = 0 
        self.lIl102A0lIl = 0
        self.lIl102A1lIl = 0
        self.lIl102A2lIl = 0
        self.lIl102A3lIl = 0

#
class lIl101E5lIl:
    def __init__(self):
        self.lIl102A4lIl = False
        self.lIl102A5lIl = False
        self.lIl102A6lIl = False
        self.lIl102A7lIl = False
        self.lIl102A8lIl=False
        self.lIl102A9lIl=lIl101E4lIl()
        self.lIl102AAlIl = []
        self.lIl102ABlIl = 0
        self.lIl102AClIl = []
        self.lIl102ADlIl = 0
        self.lIl102AElIl = 0

#
class lIl101E6lIl:
    def __init__(self):
        self.lIl102A6lIl=False
        self.lIl102B0lIl=False
        self.lIl102B1lIl=False
        self.lIl102B2lIl=False
        self.lIl102B3lIl=False
        self.lIl102B4lIl=False
        self.lIl102B5lIl=0
        self.lIl102B6lIl=0
        self.lIl102B7lIl=0
        
        self.lIl102B8lIl = []
        self.lIl102B9lIl =0
        self.lIl102BAlIl = []
        self.lIl102BBlIl = 0
        self.lIl102BClIl = []
        self.lIl102BDlIl = 0
        self.lIl102BElIl = []
        self.lIl102BFlIl = 0
        self.lIl102C0lIl = []
        self.lIl102C1lIl = 0

#
class lIl101E7lIl:
    def __init__(self):
        self.lIl102A6lIl=False
        self.lIl102A4lIl=False
        self.lIl102A5lIl=False
        self.lIl102C5lIl=False
        self.lIl102C6lIl=False
        
        self.lIl102B5lIl=0
        self.lIl102C8lIl=0
        self.lIl102BClIl = []
        self.lIl102BDlIl = 0
        self.lIl102BFlIl = 0
        self.lIl102CClIl = 0
        self.lIl102A9lIl=lIl101E4lIl()
        self.lIl102CElIl = 0

#
class lIl101E8lIl:
    def __init__(self):
        self.topic1=""
        self.lIl102CFlIl=[]

#
class lIl101E9lIl:
    def __init__(self):
        self.lIl102D0lIl=0
        self.lIl102D1lIl=0
        self.lIl102D2lIl=0
        self.lIl102D3lIl=0
        self.lIl102D4lIl=0
        self.GrafcetRun=True 
                
        self.lIl102D5lIl=False
        self.lIl102D6lIl=False
        self.lIl102D7lIl=False
        self.lIl102D8lIl=False
        self.lIl102D9lIl=False

        self.CyclicCounter=63000 
        self.ActiveCounter=0 
        self.lIl102DAlIl=0
        self.PlcCyclicTimeMs=0  
        self.lIl102DBlIl=0
        self.lIl102DClIl=0
        self.Version=0x1008 
        self.lIl102DDlIl=0

        self.Password=""
        self.OemName=""

        
        self.lIl102DElIl=bytes([0x0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00])
        self.lIl102DFlIl=bytes([0x0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00])
    
    
    def lIl1004BlIl(self, lIl1004ClIl):
        return struct.pack("=i", lIl1004ClIl)

    def lIl1004DlIl(self, lIl1004ElIl, lIl1004FlIl):
        for b in lIl1004FlIl:
            lIl1004ElIl.append(b)

    def lIl10050lIl(self, lIl10051lIl):
        lIl10052lIl=lIl101DFlIl()
        
        
        lIl10052lIl.lIl10004lIl(self.GrafcetRun)
        lIl10052lIl.lIl10004lIl(self.lIl102D5lIl)
        lIl10052lIl.lIl10004lIl(self.lIl102D8lIl)
        lIl10052lIl.lIl10004lIl(self.lIl102D9lIl) 

        lIl10052lIl.lIl10009lIl(self.CyclicCounter)
        lIl10052lIl.lIl10009lIl(self.ActiveCounter)
        lIl10052lIl.lIl10009lIl(self.PlcCyclicTimeMs)
        lIl10052lIl.lIl10009lIl(self.Version)
        lIl10052lIl.lIl10009lIl(0) 
        lIl10052lIl.lIl10009lIl(0) 

        lIl10052lIl.lIl10013lIl(self.lIl102DElIl)
        lIl10052lIl.lIl10013lIl(self.lIl102DFlIl)
        lIl10052lIl.lIl10009lIl(lIl101E1lIl.lIl101F5lIl)
        lIl10052lIl.lIl10009lIl(lIl101E1lIl.lIl101F6lIl)
        lIl10052lIl.lIl10009lIl(lIl101E1lIl.lIl101F4lIl)
        lIl10052lIl.lIl10009lIl(lIl101E1lIl.lIl101EElIl)
        lIl10052lIl.lIl10009lIl(lIl101E1lIl.lIl101F2lIl)
        lIl10052lIl.lIl10009lIl(lIl101E1lIl.lIl101F3lIl)
        lIl10052lIl.lIl10009lIl(lIl101E1lIl.lIl101F0lIl)
        lIl10052lIl.lIl10009lIl(0) 
        lIl10052lIl.lIl10009lIl(lIl101E1lIl.lIl101EFlIl)
        lIl10052lIl.lIl10009lIl(lIl101E1lIl.lIl101F1lIl)
        lIl10052lIl.lIl10009lIl(self.lIl102D4lIl)
        lIl10052lIl.lIl10009lIl(lIl101E1lIl.lIl101FFlIl)
        lIl10052lIl.lIl10009lIl(lIl101E1lIl.lIl101EDlIl)

        lIl10052lIl.lIl10009lIl(lIl10051lIl.lIl1026DlIl)
        lIl10052lIl.lIl10009lIl(lIl10051lIl.lIl1027FlIl)
        lIl10052lIl.lIl10009lIl(lIl10051lIl.lIl10271lIl)
        lIl10052lIl.lIl10009lIl(lIl10051lIl.lIl1026FlIl)
        lIl10052lIl.lIl10009lIl(lIl10051lIl.lIl1027DlIl)
        lIl10052lIl.lIl10009lIl(lIl10051lIl.lIl10273lIl)
        lIl10052lIl.lIl10009lIl(lIl10051lIl.lIl1026ElIl)
        lIl10052lIl.lIl10009lIl(lIl10051lIl.lIl1027ElIl)
        lIl10052lIl.lIl10009lIl(lIl10051lIl.lIl10272lIl)
        lIl10052lIl.lIl10009lIl(lIl10051lIl.lIl10270lIl)
        lIl10052lIl.lIl10009lIl(lIl10051lIl.lIl1027ClIl)
        lIl10052lIl.lIl10009lIl(lIl10051lIl.lIl10274lIl)
        lIl10052lIl.lIl10009lIl(lIl10051lIl.lIl10277lIl)
        lIl10052lIl.lIl10009lIl(lIl10051lIl.lIl10279lIl)
        
        lIl10052lIl.lIl10009lIl(self.lIl102D0lIl)
        lIl10052lIl.lIl10009lIl(self.lIl102D1lIl)
        lIl10052lIl.lIl10009lIl(self.lIl102D2lIl)
        lIl10052lIl.lIl10009lIl(self.lIl102D3lIl)
        lIl10052lIl.lIl10009lIl(self.lIl102DBlIl)
        lIl10052lIl.lIl10009lIl(self.lIl102DClIl)

        return lIl10052lIl.lIl10015lIl()

class lIl101EAlIl:
    def __init__(self):
        self.lIl102E0lIl = Any32()
        self.lIl102E1lIl=False
    
#
class GrafcetEngine: 
    
    def __init__(self):
        self.lIl102E2lIl=0
        self.lIl102E3lIl=0
        self.lIl102E4lIl=0
        self.lIl102E5lIl=0
        self.lIl102E6lIl=None
        self._mqtt1Topic1=""
        self._mqtt1Topic2=""
        self.lIl102E7lIl=False
        self.lIl102E8lIl=False
        self.lIl102E9lIl=None
        self.lIl102EAlIl=None
        self.lIl102EBlIl=None
        self.lIl102EClIl=True
        self.lIl102EDlIl=False
        self.lIl102EElIl=False
        self.lIl102EFlIl=time.time()
        self.lIl102F0lIl=time.time()
        self.lIl102F1lIl=False
        self.lIl102F2lIl=False
        self.lIl102F3lIl=False

        self.lIl102F4lIl = []
        self.lIl102F5lIl = []
        self.lIl102F6lIl = []
        self.lIl102F7lIl = []
        self.lIl102F8lIl=[]
        self.lIl102F9lIl=None
        self.lIl102FAlIl=0
        self.lIl102FBlIl=[]
        self.lIl102FClIl=0
                
        self.GrafcetEngineStatus=lIl101E9lIl() 

        self.lIl102FDlIl=False 
        self.lIl102FElIl=False 
        self.lIl102FFlIl = Any32()
        self.lIl10300lIl = Any32()
        self.lIl10301lIl=0.0 
        self.lIl10302lIl=0.0 
        self.lIl10303lIl = 0
        self.lIl10304lIl=Any32()
        self.lIl10305lIl=Any32()
        self.lIl10306lIl=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0] 
        self.lIl10307lIl=[] 
        
        self.lIl10308lIl = 0
        self.lIl10309lIl = False
        self.lIl1030AlIl = False
        self.lIl1030BlIl=None
        self.lIl1030ClIl = 0
        self.lIl1030DlIl = 0
        
        self.lIl1030ElIl=time.time()
        self.lIl102E3lIl=self.lIl10145lIl()
        self.lIl102F9lIl=lIl101E2lIl()
        self.lIl102E9lIl=lIl101DFlIl()
        self.lIl102E9lIl.lIl10001lIl(lIl101E1lIl.lIl101FFlIl)
        self.lIl102EAlIl=lIl101DFlIl()
        self.lIl102EAlIl.lIl10001lIl(lIl101E1lIl.lIl101FFlIl)
        for i in range(lIl101E1lIl.lIl101EBlIl): 
            lIl10053lIl=lIl101EAlIl()
            self.lIl10307lIl.append(lIl10053lIl)
        
        self.lIl102EBlIl=bytearray(lIl101E1lIl.lIl10200lIl) 
        self.lIl1030BlIl = {
            lIl101E1lIl.lIl10201lIl : self.lIl100D0lIl,
            lIl101E1lIl.lIl10202lIl : self.lIl100D1lIl,
            lIl101E1lIl.lIl10203lIl : self.lIl100D2lIl,
            lIl101E1lIl.lIl10204lIl : self.lIl100D3lIl,
            lIl101E1lIl.lIl10205lIl : self.lIl100D4lIl,
            lIl101E1lIl.lIl10206lIl : self.lIl100D5lIl,
            lIl101E1lIl.lIl10207lIl : self.lIl100D6lIl,
            lIl101E1lIl.lIl10208lIl : self.lIl100D7lIl,
            lIl101E1lIl.lIl10209lIl : self.lIl100D8lIl,
            lIl101E1lIl.lIl1020AlIl : self.lIl100D9lIl,
            lIl101E1lIl.lIl1020BlIl : self.lIl100DAlIl,
            lIl101E1lIl.lIl1020ClIl : self.lIl100DBlIl,
            lIl101E1lIl.lIl1020DlIl : self.lIl100DClIl,
            lIl101E1lIl.lIl1020ElIl : self.lIl100DDlIl,
            lIl101E1lIl.lIl1020FlIl : self.lIl100DElIl,
            lIl101E1lIl.lIl10210lIl : self.lIl100DFlIl,
            lIl101E1lIl.lIl10211lIl : self.lIl100E0lIl,
            lIl101E1lIl.lIl10212lIl : self.lIl100E1lIl,
            lIl101E1lIl.lIl10213lIl : self.lIl100E2lIl,
            lIl101E1lIl.lIl10214lIl : self.lIl100E3lIl,
            lIl101E1lIl.lIl10215lIl : self.lIl100E4lIl,
            lIl101E1lIl.lIl10216lIl : self.lIl100E5lIl,
            lIl101E1lIl.lIl10217lIl : self.lIl100E6lIl,
            lIl101E1lIl.lIl10218lIl : self.lIl100E7lIl,
            lIl101E1lIl.lIl10219lIl : self.lIl100E8lIl,
            lIl101E1lIl.lIl1021AlIl : self.lIl100E9lIl,
            lIl101E1lIl.lIl1021BlIl : self.lIl100EAlIl,
            lIl101E1lIl.lIl1021ClIl : self.lIl100EBlIl,
            lIl101E1lIl.lIl1021DlIl : self.lIl100EClIl,
            lIl101E1lIl.lIl1021ElIl : self.lIl100EDlIl,
            lIl101E1lIl.lIl1021FlIl : self.lIl100EElIl,
            lIl101E1lIl.lIl10220lIl : self.lIl100EFlIl,
            lIl101E1lIl.lIl10221lIl : self.lIl100F0lIl,
            lIl101E1lIl.lIl10222lIl : self.lIl100F1lIl,
            lIl101E1lIl.lIl10223lIl : self.lIl100F2lIl,
            lIl101E1lIl.lIl10224lIl : self.lIl100F3lIl,
            lIl101E1lIl.lIl10225lIl : self.lIl100F4lIl,
            lIl101E1lIl.lIl10226lIl : self.lIl100F5lIl,
            lIl101E1lIl.lIl10227lIl : self.lIl100F6lIl,
            lIl101E1lIl.lIl10228lIl : self.lIl100F7lIl,
            lIl101E1lIl.lIl10229lIl : self.lIl100F8lIl,
            lIl101E1lIl.lIl1022AlIl : self.lIl100F9lIl,
            lIl101E1lIl.lIl1022BlIl : self.lIl100FAlIl,
            lIl101E1lIl.lIl1022ClIl : self.lIl100FBlIl,
            lIl101E1lIl.lIl1022DlIl : self.lIl100FClIl,
            lIl101E1lIl.lIl1022ElIl : self.lIl100FDlIl,
            lIl101E1lIl.lIl1022FlIl : self.lIl100FElIl,
            lIl101E1lIl.lIl10230lIl : self.lIl100FFlIl,
            lIl101E1lIl.lIl10231lIl : self.lIl10100lIl,
            lIl101E1lIl.lIl10232lIl : self.lIl10101lIl,
            lIl101E1lIl.lIl10233lIl : self.lIl10102lIl,
            lIl101E1lIl.lIl10234lIl : self.lIl10103lIl,
            lIl101E1lIl.lIl10235lIl : self.lIl10104lIl,
            lIl101E1lIl.lIl10236lIl : self.lIl10105lIl,
            lIl101E1lIl.lIl10237lIl : self.lIl10106lIl,
            lIl101E1lIl.lIl10238lIl : self.lIl10107lIl,
            lIl101E1lIl.lIl10239lIl : self.lIl10108lIl,
            lIl101E1lIl.lIl1023AlIl : self.lIl10109lIl,
            lIl101E1lIl.lIl1023BlIl : self.lIl1010AlIl,
            lIl101E1lIl.lIl1023ClIl : self.lIl1010BlIl,
            lIl101E1lIl.lIl1023DlIl : self.lIl1010ClIl,
            lIl101E1lIl.lIl1023ElIl : self.lIl1010DlIl,
            lIl101E1lIl.lIl1023FlIl : self.lIl1010ElIl,
            lIl101E1lIl.lIl10240lIl : self.lIl1010FlIl,
            lIl101E1lIl.lIl10241lIl : self.lIl10110lIl,
            lIl101E1lIl.lIl10242lIl : self.lIl10111lIl,
            lIl101E1lIl.lIl10243lIl : self.lIl10112lIl,
            lIl101E1lIl.lIl10244lIl : self.lIl10113lIl,
            lIl101E1lIl.lIl10245lIl : self.lIl10114lIl,
            lIl101E1lIl.lIl10246lIl : self.lIl10115lIl,
            lIl101E1lIl.lIl10247lIl : self.lIl10116lIl,
            lIl101E1lIl.lIl10248lIl : self.lIl10117lIl,
            lIl101E1lIl.lIl10249lIl : self.lIl10118lIl,
            lIl101E1lIl.lIl1024AlIl : self.lIl10119lIl,
            lIl101E1lIl.lIl1024BlIl : self.lIl1011AlIl,
            lIl101E1lIl.lIl1024ClIl : self.lIl1011BlIl,
            lIl101E1lIl.lIl1024DlIl : self.lIl1011ClIl,
            lIl101E1lIl.lIl1024ElIl : self.lIl1011DlIl,
            lIl101E1lIl.lIl1024FlIl : self.lIl1011ElIl,
            lIl101E1lIl.lIl10250lIl : self.lIl1011FlIl,
            lIl101E1lIl.lIl10251lIl : self.lIl10120lIl,
            lIl101E1lIl.lIl10252lIl : self.lIl10121lIl,
            lIl101E1lIl.lIl10253lIl : self.lIl10122lIl,
            lIl101E1lIl.lIl10254lIl : self.lIl10123lIl,
            lIl101E1lIl.lIl10255lIl : self.lIl10124lIl,
            lIl101E1lIl.lIl10256lIl : self.lIl10125lIl,
            lIl101E1lIl.lIl10257lIl : self.lIl10126lIl,
            lIl101E1lIl.lIl10258lIl : self.lIl10127lIl,
            lIl101E1lIl.lIl10259lIl : self.lIl10128lIl,
            lIl101E1lIl.lIl1025AlIl : self.lIl10129lIl,
            lIl101E1lIl.lIl1025BlIl : self.lIl1012AlIl,
            lIl101E1lIl.lIl1025ClIl : self.lIl1012BlIl,
            lIl101E1lIl.lIl1025DlIl : self.lIl1012ClIl,
            lIl101E1lIl.lIl1025ElIl : self.lIl1012DlIl,
            lIl101E1lIl.lIl1025FlIl : self.lIl1012ElIl,
            lIl101E1lIl.lIl10260lIl : self.lIl1012FlIl,
            lIl101E1lIl.lIl10261lIl : self.lIl10130lIl,
            lIl101E1lIl.lIl10262lIl : self.lIl10131lIl,
            lIl101E1lIl.lIl10263lIl : self.lIl10132lIl,
            lIl101E1lIl.lIl10264lIl : self.lIl10133lIl,
            lIl101E1lIl.lIl10265lIl : self.lIl10134lIl,
            lIl101E1lIl.lIl10266lIl : self.lIl10135lIl,
            lIl101E1lIl.lIl10267lIl : self.lIl10136lIl,
            lIl101E1lIl.lIl10268lIl : self.lIl10137lIl,
            lIl101E1lIl.lIl10269lIl : self.lIl10138lIl,
            lIl101E1lIl.lIl1026AlIl : self.lIl10139lIl,
            lIl101E1lIl.lIl1026BlIl : self.lIl1013AlIl,
            lIl101E1lIl.lIl1026ClIl: self.lIl1013BlIl
        }


    def Debug(self, message): 
        if self.lIl102EClIl==False:
            return
        print(message)

    def lIl10054lIl(self):
        lIl10055lIl=["steps.bin","transitions.bin","actions.bin","commands.bin","TS1.bin","TS2.bin","io_settings.bin"]
        lIl10056lIl = os.path.dirname(os.path.realpath(__file__))
        foldername="__grafcet_data"+self._mqtt1Topic2
        lIl10056lIl=os.path.join(lIl10056lIl, foldername)
        for nameOfFile in lIl10055lIl:
            lIl10058lIl=os.path.join(lIl10056lIl, nameOfFile)
            if os.path.exists(lIl10058lIl): 
                os.remove(lIl10058lIl)
                pass
        
    def lIl10059lIl(self, lIl1005AlIl, lIl1005BlIl):
        try:
            lIl1005ClIl = os.path.dirname(os.path.realpath(__file__))
            foldername="__grafcet_data"+self._mqtt1Topic2
            lIl1005ClIl=os.path.join(lIl1005ClIl, foldername)
            if not os.path.isdir(lIl1005ClIl):
                os.mkdir(lIl1005ClIl)
            lIl1005ElIl=os.path.join(lIl1005ClIl, lIl1005AlIl)
            lIl1005FlIl=os.getcwd()
            lIl10060lIl = open(lIl1005ElIl, "wb")
            lIl10060lIl.write(lIl1005BlIl)
            lIl10060lIl.close()
        except: pass    

    def lIl10061lIl(self, lIl10062lIl):
        try:
            foldername="__grafcet_data"+self._mqtt1Topic2
            lIl10063lIl = os.path.dirname(os.path.realpath(__file__))
            lIl10064lIl=os.path.join(lIl10063lIl, foldername, lIl10062lIl)
            lIl10065lIl=Path(lIl10064lIl)
            if not lIl10065lIl.is_file(): return []
            
            lIl10066lIl = open(lIl10064lIl, "rb")
            lIl10067lIl=os.path.getsize(lIl10064lIl)
            lIl10068lIl=lIl10066lIl.read(lIl10067lIl)
            lIl10066lIl.close()    
            return lIl10068lIl
        except: return[]    
    def lIl10069lIl(self):
        try:
            self.GrafcetEngineStatus.GrafcetRun=False
            self.lIl100CBlIl(False)
            lIl1006AlIl=self.lIl10061lIl("lIl1006AlIl.bin")
            lIl1006BlIl=self.lIl10061lIl("lIl1006BlIl.bin")
            lIl1006ClIl=self.lIl10061lIl("lIl1006ClIl.bin")
            lIl1006DlIl=self.lIl10061lIl("lIl1006DlIl.bin")
            lIl1006ElIl=self.lIl10061lIl("TS1.bin")
            lIl1006FlIl=self.lIl10061lIl("TS2.bin")
            lIl10070lIl=self.lIl10061lIl("io_settings.bin")
            lIl10071lIl=lIl1006AlIl.__len__()
            lIl10072lIl=lIl1006BlIl.__len__()
            lIl10073lIl=lIl1006ClIl.__len__()
            lIl10074lIl=lIl1006DlIl.__len__()
            if lIl1006ElIl.__len__()>0 and lIl1006FlIl.__len__()>0 and lIl10070lIl.__len__()>0:
                self.lIl102F9lIl.lIl10047lIl(lIl10070lIl)
                self.lIl100B6lIl(lIl1006AlIl)
                self.lIl100BClIl(lIl1006BlIl)           
                self.lIl100C2lIl(lIl1006ClIl)                 
                self.lIl100C8lIl(lIl1006DlIl)           
                self.GrafcetEngineStatus.lIl102DElIl=lIl1006ElIl
                self.GrafcetEngineStatus.lIl102DFlIl =lIl1006FlIl
            self.GrafcetEngineStatus.GrafcetRun=True    
        except:
            pass


    def write_bit(self, byteAddr, bitAddr, bitvalue): 
        """
        Write a value (bit) into the input/output area (symbols) of the Grafcet-Engine.
        byteAddr: This is the target byte address for writing. 
        bitAddr: This is the target bit address for writing.
        bitValue: This is 0,1,True or False
        Important: look into the symbol table in Grafcet-Studio to use the correct address for the symbol.
        """
        self.lIl102E9lIl.lIl10038lIl(byteAddr, bitAddr, bitvalue)
        
    def write_uint8(self, byteAddr, ui8value): 
        """
        Write a uint8 value into the input/output area (symbols) of the Grafcet-Engine.
        byteAddr: This is the target byte address for writing. 
        ui8Value: This is the (byte) value to write
        Important: look into the symbol table in Grafcet-Studio to use the correct address for the symbol.
        """
        self.lIl102E9lIl.lIl10035lIl(byteAddr, ui8value)
    
    def write_uint16(self, byteAddr, ui16value): 
        """
        Write a uint16 value into the input/output area (symbols) of the Grafcet-Engine.
        byteAddr: This is the target byte address for writing. 
        ui16Value: This is the (word) value to write
        Important: look into the symbol table in Grafcet-Studio to use the correct address for the symbol.
        """
        self.lIl102E9lIl.lIl10030lIl(byteAddr, ui16value)

    def write_uint32(self, byteAddr, ui32value): 
        """
        Write a uint32 value into the input/output area (symbols) of the Grafcet-Engine.
        byteAddr: This is the target byte address for writing. 
        ui32Value: This is the (d-word) value to write
        Important: look into the symbol table in Grafcet-Studio to use the correct address for the symbol.
        """
        self.lIl102E9lIl.lIl1002ClIl(byteAddr, ui32value)
    
    def write_int16(self, byteAddr, i16value): 
        """
        Write a int16 (16 bits) value into the input/output area (symbols) of the Grafcet-Engine.
        byteAddr: This is the target byte address for writing. 
        i16Value: This is the (int16) value to write
        Important: look into the symbol table in Grafcet-Studio to use the correct address for the symbol.
        """
        lIl10075lIl = Any32()
        lIl10075lIl.i.INT16_0=i16value
        self.lIl102E9lIl.lIl10030lIl(byteAddr, lIl10075lIl.w.UINT16_0)

    def write_int32(self, byteAddr, i32value):
        """
        Write a int32 (32 bits) value into the input/output area (symbols) of the Grafcet-Engine.
        byteAddr: This is the target byte address for writing. 
        i32Value: This is the (int32) value to write
        Important: look into the symbol table in Grafcet-Studio to use the correct address for the symbol.
        """
        lIl10076lIl = Any32()
        lIl10076lIl.INT32=i32value
        self.lIl102E9lIl.lIl1002ClIl(byteAddr, lIl10076lIl.UINT32)    
    
    def write_float(self, byteAddr, floatvalue):
        """
        Write a float (32 bits) value into the input/output area (symbols) of the Grafcet-Engine.
        byteAddr: This is the target byte address for writing. 
        floatValue: This is the (float) value to write
        Important: look into the symbol table in Grafcet-Studio to use the correct address for the symbol.
        """
        lIl10077lIl = Any32()
        lIl10077lIl.FLOAT_0=floatvalue
        self.lIl102E9lIl.lIl1002ClIl(byteAddr,lIl10077lIl.UINT32)

    def read_bit(self, byteAddr, bitAddr):
        """
        Read a bit value (symbol) from the input/output area of the Grafcet-Engine.
        byteAddr: This is the source byte address for reading. 
        bitAddr: This is the source bit address for reading.
        return value: the value
        Important: look into the symbol table in Grafcet-Studio to use the correct address for the symbol.
        """
        return self.lIl102E9lIl.lIl10016lIl(byteAddr, bitAddr)
    
    def read_uint8(self, byteAddr):
        """
        Read a byte value (symbol) from the input/output area of the Grafcet-Engine.
        byteAddr: This is the source byte address for reading. 
        return value: the value
        Important: look into the symbol table in Grafcet-Studio to use the correct address for the symbol.
        """
        return self.lIl102E9lIl.lIl10027lIl(byteAddr)

    def read_uint16(self, byteAddr):
        """
        Read a uint16 value (symbol) from the input/output area of the Grafcet-Engine.
        byteAddr: This is the source byte address for reading. 
        return value: the value
        Important: look into the symbol table in Grafcet-Studio to use the correct address for the symbol.
        """
        return self.lIl102E9lIl.lIl1001FlIl(byteAddr)

    def read_uint32(self, byteAddr):
        """
        Read a uint32 value (symbol) from the input/output area of the Grafcet-Engine.
        byteAddr: This is the source byte address for reading. 
        return value: the value
        Important: look into the symbol table in Grafcet-Studio to use the correct address for the symbol.
        """
        return self.lIl102E9lIl.lIl10025lIl(byteAddr)
    
    def read_int16(self, byteAddr):
        """
        Read a int16 value (symbol) from the input/output area of the Grafcet-Engine.
        byteAddr: This is the source byte address for reading. 
        return value: the value
        Important: look into the symbol table in Grafcet-Studio to use the correct address for the symbol.
        """
        return self.lIl102E9lIl.lIl1001BlIl(byteAddr)
    
    def read_int32(self, byteAddr):
        """
        Read a int32 value (symbol) from the input/output area of the Grafcet-Engine.
        byteAddr: This is the source byte address for reading. 
        return value: the value
        Important: look into the symbol table in Grafcet-Studio to use the correct address for the symbol.
        """
        return self.lIl102E9lIl.lIl1001DlIl(byteAddr)
    
    def read_float(self, byteAddr):
        """
        Read a float value (symbol) from the input/output area of the Grafcet-Engine.
        byteAddr: This is the source byte address for reading. 
        return value: the value
        Important: look into the symbol table in Grafcet-Studio to use the correct address for the symbol.
        """
        return self.lIl102E9lIl.lIl10019lIl(byteAddr)
    
    
    def lIl10078lIl(self, lIl10079lIl, lIl1007AlIl, lIl1007BlIl):
        lIl1007ClIl=lIl10079lIl
        lIl1007DlIl=lIl1007AlIl
        lIl1007ElIl=0
        lIl1007FlIl=lIl1007BlIl
        
        lIl1007ClIl.lIl102A6lIl		= lIl1007DlIl.lIl10016lIl(lIl1007FlIl, lIl1007ElIl); lIl1007ElIl+=1
        lIl1007ClIl.lIl102B0lIl = lIl1007DlIl.lIl10016lIl(lIl1007FlIl, lIl1007ElIl); lIl1007ElIl+=1
        lIl1007ClIl.lIl102B1lIl = lIl1007DlIl.lIl10016lIl(lIl1007FlIl, lIl1007ElIl); lIl1007ElIl+=1
        lIl1007ClIl.lIl102B2lIl = lIl1007DlIl.lIl10016lIl(lIl1007FlIl, lIl1007ElIl); lIl1007ElIl+=1
        lIl1007ClIl.lIl102B3lIl		= lIl1007DlIl.lIl10016lIl(lIl1007FlIl, lIl1007ElIl); lIl1007ElIl+=1
        lIl1007ClIl.lIl102B4lIl = lIl1007DlIl.lIl10016lIl(lIl1007FlIl, lIl1007ElIl); lIl1007ElIl+=1
        lIl1007FlIl+=1

        lIl1007ClIl.lIl102B5lIl = lIl1007DlIl.lIl10027lIl(lIl1007FlIl)
        lIl1007FlIl+=1
        lIl1007ClIl.lIl102B6lIl = lIl1007DlIl.lIl10027lIl(lIl1007FlIl)
        lIl1007FlIl+=1
        lIl1007ClIl.lIl102B7lIl = lIl1007DlIl.lIl10027lIl(lIl1007FlIl)
        lIl1007FlIl+=1

        lIl1007ClIl.lIl102B9lIl = lIl1007DlIl.lIl10021lIl(lIl1007FlIl)
        lIl1007FlIl += 2
        lIl1007ClIl.lIl102B8lIl=bytearray()
        lIl1007DlIl.lIl1000FlIl(lIl1007ClIl.lIl102B8lIl, lIl1007FlIl, lIl1007ClIl.lIl102B9lIl)
        lIl1007FlIl+=lIl1007ClIl.lIl102B9lIl
        if lIl1007FlIl%2: lIl1007FlIl+=1

        lIl1007ClIl.lIl102BBlIl = lIl1007DlIl.lIl10021lIl(lIl1007FlIl)
        lIl1007FlIl += 2
        lIl1007ClIl.lIl102BAlIl=bytearray()
        lIl1007DlIl.lIl1000FlIl(lIl1007ClIl.lIl102BAlIl, lIl1007FlIl, lIl1007ClIl.lIl102BBlIl)
        lIl1007FlIl+=lIl1007ClIl.lIl102BBlIl
        if lIl1007FlIl%2: lIl1007FlIl+=1
        
        lIl1007ClIl.lIl102BDlIl = lIl1007DlIl.lIl10021lIl(lIl1007FlIl)
        lIl1007FlIl += 2
        lIl1007ClIl.lIl102BClIl=bytearray()
        lIl1007DlIl.lIl1000FlIl(lIl1007ClIl.lIl102BClIl, lIl1007FlIl, lIl1007ClIl.lIl102BDlIl)
        lIl1007FlIl+=lIl1007ClIl.lIl102BDlIl
        if lIl1007FlIl%2: lIl1007FlIl+=1

        lIl1007ClIl.lIl102BFlIl = lIl1007DlIl.lIl10021lIl(lIl1007FlIl)
        lIl1007FlIl += 2
        
        
        
        
        

        lIl1007ClIl.lIl102C1lIl = lIl1007DlIl.lIl10021lIl(lIl1007FlIl)
        lIl1007FlIl += 2
        lIl1007ClIl.lIl102C0lIl=bytearray()
        lIl1007DlIl.lIl1000FlIl(lIl1007ClIl.lIl102C0lIl, lIl1007FlIl, lIl1007ClIl.lIl102C1lIl)
        lIl1007FlIl+=lIl1007ClIl.lIl102C1lIl
        if lIl1007FlIl%2: lIl1007FlIl+=1
        return lIl1007FlIl
        

    
    def lIl10080lIl(self, lIl10081lIl, lIl10082lIl, lIl10083lIl):
        try:
            lIl10084lIl = 0
            lIl10085lIl=lIl10082lIl
            lIl10086lIl=lIl10083lIl
            lIl10087lIl=lIl10081lIl

            lIl10087lIl.lIl10293lIl = lIl10085lIl.lIl10016lIl(lIl10086lIl, lIl10084lIl)
            lIl10084lIl+=1
            lIl10087lIl.lIl10294lIl = lIl10085lIl.lIl10016lIl(lIl10086lIl, lIl10084lIl)
            lIl10084lIl+=1

            lIl10087lIl.lIl10295lIl = False
            lIl10084lIl+=1

            lIl10087lIl.lIl10296lIl = False
            lIl10084lIl+=1

            lIl10087lIl.lIl10297lIl = False
            lIl10084lIl+=1

            lIl10087lIl.lIl10298lIl = False
            lIl10084lIl+=1

            lIl10087lIl.lIl10299lIl = lIl10085lIl.lIl10016lIl(lIl10086lIl, lIl10084lIl)
            lIl10084lIl+=1

            lIl10087lIl.lIl1029AlIl = lIl10085lIl.lIl10016lIl(lIl10086lIl, lIl10084lIl)
            lIl10084lIl+=1

            lIl10084lIl = 0
            lIl10086lIl+=1 

            lIl10087lIl.lIl1029BlIl = False
            lIl10084lIl+=1

            lIl10087lIl.lIl1029ClIl = False
            lIl10084lIl+=1

            lIl10087lIl.lIl1029DlIl = lIl10085lIl.lIl10016lIl(lIl10086lIl, lIl10084lIl)
            lIl10084lIl+=1
            lIl10086lIl+=1 

            lIl10087lIl.lIl1029ElIl = lIl10085lIl.lIl10021lIl(lIl10086lIl) 
            lIl10086lIl += 2
            lIl10087lIl.lIl1029FlIl = lIl10085lIl.lIl10021lIl(lIl10086lIl) 
            lIl10086lIl += 2

            lIl10087lIl.lIl102A0lIl = 0 
            lIl10086lIl += 4 
            lIl10087lIl.lIl102A1lIl = 0 
            lIl10086lIl += 4 
            lIl10087lIl.lIl102A2lIl = lIl10085lIl.lIl10023lIl(lIl10086lIl)
            lIl10086lIl += 4 
            lIl10087lIl.lIl102A3lIl = lIl10085lIl.lIl10023lIl(lIl10086lIl)
            lIl10086lIl += 4 
            return lIl10086lIl
        except:
            pass


    
    def lIl10089lIl(self, lIl1008AlIl, lIl1008BlIl, lIl1008ClIl):
        try:
            lIl1008DlIl= lIl1008AlIl
            lIl1008ElIl=lIl1008BlIl
            lIl1008FlIl = 0
            lIl10090lIl=lIl1008ClIl
            
            lIl1008DlIl.lIl102A4lIl = lIl1008ElIl.lIl10016lIl(lIl10090lIl, lIl1008FlIl); lIl1008FlIl+=1
            lIl1008DlIl.lIl102A5lIl = lIl1008ElIl.lIl10016lIl(lIl10090lIl, lIl1008FlIl); lIl1008FlIl+=1
            lIl1008DlIl.lIl102A6lIl = lIl1008ElIl.lIl10016lIl(lIl10090lIl, lIl1008FlIl); lIl1008FlIl+=1
            lIl1008DlIl.lIl102A7lIl = lIl1008ElIl.lIl10016lIl(lIl10090lIl, lIl1008FlIl); lIl1008FlIl+=1
            lIl1008DlIl.lIl102A8lIl= lIl1008ElIl.lIl10016lIl(lIl10090lIl, lIl1008FlIl); lIl1008FlIl+=1 
            lIl10090lIl+=1
            lIl10090lIl+=1

            lIl1008DlIl.lIl102A9lIl=lIl101E4lIl()
            lIl10091lIl=self.lIl10080lIl(lIl1008DlIl.lIl102A9lIl, lIl1008ElIl, lIl10090lIl)
            if not lIl1008DlIl.lIl102A9lIl.lIl10293lIl and not lIl1008DlIl.lIl102A9lIl.lIl10294lIl:
                lIl1008DlIl.lIl102A9lIl=None
            lIl10090lIl=lIl10091lIl
            
            lIl1008DlIl.lIl102ABlIl = lIl1008ElIl.lIl10021lIl(lIl10090lIl)
            lIl10090lIl += 2
            lIl1008DlIl.lIl102AAlIl=bytearray()
            lIl1008ElIl.lIl1000FlIl(lIl1008DlIl.lIl102AAlIl, lIl10090lIl, lIl1008DlIl.lIl102ABlIl)
            lIl10090lIl+=lIl1008DlIl.lIl102ABlIl
            if lIl10090lIl%2: lIl10090lIl+=1
            
            lIl1008DlIl.lIl102ADlIl = lIl1008ElIl.lIl10021lIl(lIl10090lIl)
            lIl10090lIl += 2
            lIl1008DlIl.lIl102AClIl=bytearray()
            lIl1008ElIl.lIl1000FlIl(lIl1008DlIl.lIl102AClIl, lIl10090lIl, lIl1008DlIl.lIl102ADlIl)
            lIl10090lIl+=lIl1008DlIl.lIl102ADlIl
            if lIl10090lIl%2: lIl10090lIl+=1
            
            lIl1008DlIl.lIl102AElIl = lIl1008ElIl.lIl10021lIl(lIl10090lIl)
            lIl10090lIl+=2
            return lIl10090lIl
        except:
            pass

    def lIl10093lIl(self, lIl10094lIl, lIl10095lIl, lIl10096lIl):
        try:
            lIl10097lIl = 0
            lIl10098lIl=lIl10096lIl
            lIl10099lIl=lIl10094lIl
            lIl1009AlIl=lIl10095lIl
            
            lIl10099lIl.lIl102A6lIl = lIl1009AlIl.lIl10016lIl(lIl10098lIl, lIl10097lIl); lIl10097lIl+=1
            lIl10099lIl.lIl102A4lIl = lIl1009AlIl.lIl10016lIl(lIl10098lIl, lIl10097lIl); lIl10097lIl+=1
            lIl10099lIl.lIl102A5lIl = lIl1009AlIl.lIl10016lIl(lIl10098lIl, lIl10097lIl); lIl10097lIl+=1
            lIl10099lIl.lIl102C5lIl = lIl1009AlIl.lIl10016lIl(lIl10098lIl, lIl10097lIl); lIl10097lIl+=1
            lIl10099lIl.lIl102C6lIl = lIl1009AlIl.lIl10016lIl(lIl10098lIl, lIl10097lIl); lIl10097lIl+=1
            lIl10098lIl+=1

            lIl10099lIl.Reserved = lIl1009AlIl.lIl10027lIl(lIl10098lIl); lIl10098lIl+=1
            lIl10099lIl.lIl102B5lIl = lIl1009AlIl.lIl10027lIl(lIl10098lIl); lIl10098lIl+=1
            lIl10099lIl.lIl102C8lIl = lIl1009AlIl.lIl10027lIl(lIl10098lIl); lIl10098lIl+=1

            lIl10099lIl.lIl102BDlIl = lIl1009AlIl.lIl10021lIl(lIl10098lIl)
            lIl10098lIl += 2
            lIl10099lIl.lIl102BClIl = bytearray()
            lIl1009AlIl.lIl1000FlIl(lIl10099lIl.lIl102BClIl, lIl10098lIl, lIl10099lIl.lIl102BDlIl)
            lIl10098lIl+=lIl10099lIl.lIl102BDlIl
            if lIl10098lIl%2: lIl10098lIl+=1
            
            lIl10099lIl.lIl102BFlIl = lIl1009AlIl.lIl10021lIl(lIl10098lIl)
            lIl10098lIl += 2

            lIl10099lIl.lIl102CClIl = lIl1009AlIl.lIl10021lIl(lIl10098lIl)
            lIl10098lIl += 2

            lIl10099lIl.lIl102A9lIl=lIl101E4lIl()
            lIl1009BlIl=self.lIl10080lIl(lIl10099lIl.lIl102A9lIl, lIl1009AlIl, lIl10098lIl)
            if not lIl10099lIl.lIl102A9lIl.lIl10293lIl and not lIl10099lIl.lIl102A9lIl.lIl10294lIl:
                lIl10099lIl.lIl102A9lIl=None
            lIl10098lIl=lIl1009BlIl

            lIl10099lIl.lIl102CElIl = lIl1009AlIl.lIl10021lIl(lIl10098lIl)
            lIl10098lIl+=2
            return lIl10098lIl
        except:
            pass

    
    def lIl1009DlIl(self, lIl1009ElIl):
        try:
            lIl1009FlIl= struct.unpack('=I',lIl1009ElIl[0:0+4])[0]    
            lIl100A0lIl=struct.unpack('=H',lIl1009ElIl[4:4+2])[0]    
            lIl100A1lIl=lIl1009ElIl[6]
            lIl100A2lIl=lIl1009ElIl[7]
            #pass
            if lIl100A2lIl==1:
                self.lIl102E9lIl.lIl10038lIl(lIl100A0lIl, lIl100A1lIl, c_ubyte(lIl1009FlIl).value)
                pass
            elif lIl100A2lIl==8:
                self.lIl102E9lIl.lIl10035lIl(lIl100A0lIl, c_ubyte(lIl1009FlIl).value)
                pass
            elif lIl100A2lIl==16:
                self.lIl102E9lIl.lIl10030lIl(lIl100A0lIl, c_uint16(lIl1009FlIl).value)
                pass
            elif lIl100A2lIl==32:
                self.lIl102E9lIl.lIl1002ClIl(lIl100A0lIl, lIl1009FlIl)    
                pass
        except:
            pass

    
    def lIl100A3lIl(self, lIl100A4lIl):
        try:
            
            
            lIl100A5lIl=0
            lIl100A6lIl=struct.unpack('=h',lIl100A4lIl[lIl100A5lIl:lIl100A5lIl+2])[0];lIl100A5lIl+=2
            lIl100A7lIl=struct.unpack('=h',lIl100A4lIl[lIl100A5lIl:lIl100A5lIl+2])[0];lIl100A5lIl+=2
            lIl100A8lIl=struct.unpack('=h',lIl100A4lIl[lIl100A5lIl:lIl100A5lIl+2])[0];lIl100A5lIl+=2
            lIl100A9lIl=struct.unpack('=h',lIl100A4lIl[lIl100A5lIl:lIl100A5lIl+2])[0];lIl100A5lIl+=2
            lIl100AAlIl=struct.unpack('=h',lIl100A4lIl[lIl100A5lIl:lIl100A5lIl+2])[0];lIl100A5lIl+=2
            lIl100ABlIl=struct.unpack('=h',lIl100A4lIl[lIl100A5lIl:lIl100A5lIl+2])[0];lIl100A5lIl+=2
            lIl100AClIl=struct.unpack('=h',lIl100A4lIl[lIl100A5lIl:lIl100A5lIl+2])[0];lIl100A5lIl+=2
            
            lIl100ADlIl=self.lIl102E9lIl.lIl10029lIl(self.lIl102F9lIl.lIl10271lIl, lIl100A6lIl)
            lIl100AElIl=self.lIl102E9lIl.lIl10029lIl(self.lIl102F9lIl.lIl10272lIl, lIl100A7lIl)
            lIl100AFlIl=self.lIl102E9lIl.lIl10029lIl(self.lIl102F9lIl.lIl10273lIl, lIl100A8lIl)
            lIl100B0lIl=self.lIl102E9lIl.lIl10029lIl(self.lIl102F9lIl.lIl10274lIl, lIl100A9lIl)
            lIl100B1lIl=self.lIl102E9lIl.lIl10029lIl(self.lIl102F9lIl.lIl10275lIl, lIl100AAlIl)
            lIl100B2lIl=self.lIl102E9lIl.lIl10029lIl(self.lIl102F9lIl.lIl10276lIl, lIl100ABlIl)
            lIl100B3lIl=self.lIl102E9lIl.lIl10029lIl(self.lIl102F9lIl.lIl10277lIl, lIl100AClIl)
            lIl100B4lIl=lIl100ADlIl+lIl100AElIl+lIl100AFlIl+lIl100B0lIl+lIl100B1lIl+lIl100B2lIl+lIl100B3lIl
            self.lIl101DAlIl("SymbolData", lIl100B4lIl)
        except:        
            pass

    
    
    
    
    def lIl100B5lIl(self):
        if self.lIl102EDlIl:
            self.lIl102FBlIl=["FncC_LOAD_INT16","FncC_LOAD_D_INT16","FncC_TRANSF_D_INT16","FncC_DIV_D_I16","FncC_MUL_D_I16","FncC_SUB_D_I16","FncC_ADD_D_I16","FncC_DIV_I16","FncC_MUL_I16","FncC_SUB_I16","FncC_ADD_I16"]

    

    
    def lIl100B6lIl(self, lIl100B7lIl):
        try:
            self.GrafcetEngineStatus.GrafcetRun=False 
            if self.lIl102EElIl:time.sleep(50) 
            lIl100B8lIl=lIl101DFlIl(lIl100B7lIl) 
            if lIl100B8lIl.lIl10000lIl()==0: return
            pass
            lIl100B9lIl=0
            self.lIl102F4lIl=[]
            self.GrafcetEngineStatus.lIl102D0lIl=0
            while True:
                lIl100BAlIl=lIl101E6lIl()
                lIl100B9lIl=self.lIl10078lIl(lIl100BAlIl, lIl100B8lIl, lIl100B9lIl) 
                self.lIl102F4lIl.append(lIl100BAlIl)
                if lIl100B9lIl+1>lIl100B8lIl.lIl10000lIl():
                    break
            self.GrafcetEngineStatus.lIl102D0lIl=self.lIl102F4lIl.__len__()
            pass
            self.lIl100B5lIl()
            self.lIl10059lIl("steps.bin",lIl100B7lIl)
        except:
            pass

    
    
    def lIl100BClIl(self, lIl100BDlIl):
        try:
            self.GrafcetEngineStatus.GrafcetRun=False 
            if self.lIl102EElIl:time.sleep(50) 
            lIl100BElIl=lIl101DFlIl(lIl100BDlIl) 
            if lIl100BElIl.lIl10000lIl()==0: return
            pass
            lIl100BFlIl=0
            self.lIl102F6lIl=[]
            self.GrafcetEngineStatus.lIl102D1lIl=0
            while True:
                lIl100C0lIl=lIl101E5lIl()
                lIl100BFlIl=self.lIl10089lIl(lIl100C0lIl, lIl100BElIl, lIl100BFlIl)
                self.lIl102F6lIl.append(lIl100C0lIl)
                if lIl100BFlIl+1>lIl100BElIl.lIl10000lIl():
                    break
            self.GrafcetEngineStatus.lIl102D1lIl=self.lIl102F6lIl.__len__()
            self.lIl10059lIl("transitions.bin",lIl100BDlIl)
            pass
        except:
            pass


    
    def lIl100C2lIl(self, lIl100C3lIl):
        try:
            self.GrafcetEngineStatus.GrafcetRun=False 
            if self.lIl102EElIl:time.sleep(50) 
            lIl100C4lIl=lIl101DFlIl(lIl100C3lIl) 
            if lIl100C4lIl.lIl10000lIl()==0: return
            pass
            lIl100C5lIl=0
            self.lIl102F5lIl=[]
            self.GrafcetEngineStatus.lIl102D2lIl=0
            while True:
                lIl100C6lIl=lIl101E7lIl()
                lIl100C5lIl=self.lIl10093lIl(lIl100C6lIl, lIl100C4lIl, lIl100C5lIl)
                self.lIl102F5lIl.append(lIl100C6lIl)
                if lIl100C5lIl+1>lIl100C4lIl.lIl10000lIl():
                    break
            self.GrafcetEngineStatus.lIl102D2lIl=self.lIl102F5lIl.__len__()
            pass
            self.lIl10059lIl("actions.bin",lIl100C3lIl)
        except:
            pass


    
    def lIl100C8lIl(self, lIl100C9lIl):
        self.GrafcetEngineStatus.GrafcetRun=False 
        self.GrafcetEngineStatus.lIl102D3lIl=0
        if self.lIl102EElIl:time.sleep(50) 
        lIl100CAlIl=lIl100C9lIl.__len__()
        if lIl100CAlIl==0: return
        
        self.lIl102F7lIl = array.array('H')
        self.lIl102F7lIl.frombytes(lIl100C9lIl)
        self.lIl102F7lIl.byteswap()
        self.GrafcetEngineStatus.lIl102D3lIl=lIl100CAlIl
        self.lIl10059lIl("commands.bin",lIl100C9lIl)
        pass


    def lIl100CBlIl(self, lIl100CClIl):
        if lIl100CClIl: self.lIl10054lIl()
        self.GrafcetEngineStatus.lIl102D2lIl = 0
        self.GrafcetEngineStatus.lIl102D1lIl = 0
        self.GrafcetEngineStatus.lIl102D0lIl = 0
        self.GrafcetEngineStatus.lIl102D3lIl = 0
        self.lIl102F4lIl=[]
        self.lIl102F6lIl=[]
        self.lIl102F5lIl=[]
        self.GrafcetEngineStatus.lIl102DElIl=bytes([0x0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00])
        self.GrafcetEngineStatus.lIl102DFlIl=bytes([0x0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00])

    
    def InitMqtt(self,brokerUrl, topic11,topic12): 
        try:
            self._mqtt1Topic1=topic11
            self._mqtt1Topic2=topic12
            clientId="mhj-"+str(uuid.uuid4()) 
            self.lIl102E6lIl=mqtt.Client(clientId)
            self.lIl102E6lIl.on_connect = self.lIl101C2lIl
            self.lIl102E6lIl.on_message = self.lIl101D2lIl
            
            lIl100CDlIl=self.lIl102E6lIl.connect(brokerUrl)
            return (lIl100CDlIl==0)
        except:
            return False

    
    def lIl100CElIl(self, lIl100CFlIl):
        if self.lIl102FBlIl.count(lIl100CFlIl)>0: 
            self.lIl102FBlIl.remove(lIl100CFlIl)

    
    def lIl100D0lIl(self):
        self.lIl1030AlIl = True
        return
    def lIl100D1lIl(self):
        self.vke=True
        return
    def lIl100D2lIl(self):
        self.vke=False
        return
    def lIl100D3lIl(self):
        self.lIl102FDlIl = not self.lIl102FDlIl
        return
    def lIl100D4lIl(self):
        self.lIl10306lIl[self.lIl10308lIl] = self.lIl102FDlIl
        self.lIl102FDlIl = False
        self.lIl102FElIl = True
        self.lIl10308lIl+=1
        return
    def lIl100D5lIl(self):
        self.lIl102FDlIl = self.lIl102FFlIl.UINT32 != 0
        return
    def lIl100D6lIl(self):
        self.lIl10308lIl-=1
        self.lIl102FDlIl = self.lIl102FDlIl and self.lIl10306lIl[self.lIl10308lIl]
        return
    def lIl100D7lIl(self):
        self.lIl10308lIl-=1
        self.lIl102FDlIl = self.lIl102FDlIl or self.lIl10306lIl[self.lIl10308lIl]
        return
    def lIl100D8lIl(self):
        self.lIl10308lIl-=1
        self.lIl102FDlIl = self.lIl102FDlIl and not self.lIl10306lIl[self.lIl10308lIl]
        return
    def lIl100D9lIl(self):
        self.lIl10308lIl-=1
        self.lIl102FDlIl = self.lIl102FDlIl or not self.lIl10306lIl[self.lIl10308lIl]
        return
    def lIl100DAlIl(self):
        self.lIl10308lIl-=1
        return
    def lIl100DBlIl(self):
        if self.lIl102FElIl:
            self.lIl102FDlIl = False
        self.lIl102FElIl = False
        return
    def lIl100DClIl(self):
        self.lIl102FDlIl = True
        self.lIl102FElIl = False
        return
    def lIl100DDlIl(self):
        self.lIl102FDlIl = False
        self.lIl102FElIl = False
        return
    def lIl100DElIl(self):
        if self.lIl102FElIl:
            self.lIl102FDlIl = True
        self.lIl102FElIl = False
        return
    def lIl100DFlIl(self):
        self.lIl102E9lIl.lIl10038lIl(self.lIl1030DlIl, self.lIl1030ClIl, self.lIl102FDlIl)
        return
    def lIl100E0lIl(self):
        if self.lIl102FElIl: self.lIl102FDlIl = self.lIl102E9lIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        else: self.lIl102FDlIl = self.lIl102FDlIl and self.lIl102E9lIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        self.lIl102FElIl = False
        return
    def lIl100E1lIl(self):
        if self.lIl102FElIl: self.lIl102FDlIl = not self.lIl102E9lIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        else: self.lIl102FDlIl = self.lIl102FDlIl and not self.lIl102E9lIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        self.lIl102FElIl = False
        return
    def lIl100E2lIl(self):
        if self.lIl102FElIl: self.lIl102FDlIl = self.lIl102E9lIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        else: self.lIl102FDlIl = self.lIl102FDlIl or self.lIl102E9lIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        self.lIl102FElIl = False
        return
    def lIl100E3lIl(self):
        if self.lIl102FElIl: self.lIl102FDlIl = not self.lIl102E9lIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        else: self.lIl102FDlIl = self.lIl102FDlIl or not self.lIl102E9lIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        self.lIl102FElIl = False
        return
    def lIl100E4lIl(self):
        if self.lIl102FElIl: self.lIl102FDlIl = self.lIl102EAlIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        else: self.lIl102FDlIl = self.lIl102FDlIl and self.lIl102EAlIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        self.lIl102FElIl = False
        return
    def lIl100E5lIl(self):
        if self.lIl102FElIl: self.lIl102FDlIl = not self.lIl102EAlIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        else: self.lIl102FDlIl = self.lIl102FDlIl and not self.lIl102EAlIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        self.lIl102FElIl = False
        return
    def lIl100E6lIl(self):
        if self.lIl102FElIl: self.lIl102FDlIl = self.lIl102EAlIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        else: self.lIl102FDlIl = self.lIl102FDlIl or self.lIl102EAlIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        self.lIl102FElIl = False
        return
    def lIl100E7lIl(self):
        if self.lIl102FElIl: self.lIl102FDlIl = not self.lIl102EAlIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        else: self.lIl102FDlIl = self.lIl102FDlIl or not self.lIl102EAlIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl)
        self.lIl102FElIl = False
        return
    def lIl100E8lIl(self):
        self.lIl102FFlIl.UINT32 = 0
        self.lIl10300lIl.UINT32 = 0
        return
    def lIl100E9lIl(self):
        self.lIl10301lIl = self.lIl102FFlIl.FLOAT_0
        self.lIl10309lIl = False
        return
    def lIl100EAlIl(self):
        self.lIl10302lIl = self.lIl102FFlIl.FLOAT_0
        self.lIl10309lIl = False
        return
    def lIl100EBlIl(self):
        self.lIl10309lIl = True
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 = 1.0 if self.lIl102E9lIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl) else 0.0
        return
    def lIl100EClIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 + 1.0 if self.lIl102E9lIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl) else 0.0
        return
    def lIl100EDlIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 - 1.0 if self.lIl102E9lIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl) else 0.0
        return
    def lIl100EElIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 * 1.0 if self.lIl102E9lIl.lIl10016lIl(self.lIl1030DlIl, self.lIl1030ClIl) else 0.0
        return
    def lIl100EFlIl(self):
        self.lIl102FDlIl = abs(self.lIl10301lIl - self.lIl10302lIl) < 0.0001
        self.lIl102FElIl = False
        return
    def lIl100F0lIl(self):
        self.lIl102FDlIl = abs(self.lIl10301lIl - self.lIl10302lIl) > 0.0001
        self.lIl102FElIl = False
        return
    def lIl100F1lIl(self):
        self.lIl102FDlIl = self.lIl10302lIl > self.lIl10301lIl
        self.lIl102FElIl = False
        return
    def lIl100F2lIl(self):
        self.lIl102FDlIl = self.lIl10302lIl < self.lIl10301lIl
        self.lIl102FElIl = False
        return
    def lIl100F3lIl(self):
        self.lIl102FDlIl = self.lIl10302lIl <= self.lIl10301lIl
        self.lIl102FElIl = False
        return
    def lIl100F4lIl(self):
        self.lIl102FDlIl = self.lIl10302lIl >= self.lIl10301lIl
        self.lIl102FElIl = False
        return
    
    def lIl100F5lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 + self.lIl10305lIl.b.UINT8_0
        return
    def lIl100F6lIl(self):
        if self.lIl102EDlIl: self.lIl100CElIl("FncC_ADD_UI16")
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 + self.lIl10305lIl.w.UINT16_0
        return
    def lIl100F7lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 + self.lIl10305lIl.UINT32
        self.lIl10303lIl = self.lIl10303lIl + 1 
        return
    def lIl100F8lIl(self):
        if self.lIl102EDlIl: self.lIl100CElIl("FncC_ADD_I16")
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 + self.lIl10305lIl.i.INT16_0
        return
    def lIl100F9lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 + self.lIl10305lIl.INT32
        self.lIl10303lIl = self.lIl10303lIl + 1 
        return
    def lIl100FAlIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 + self.lIl10305lIl.FLOAT_0
        self.lIl10303lIl = self.lIl10303lIl + 1 
        return
    
    def lIl100FBlIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 - self.lIl10305lIl.b.UINT8_0
        return
    def lIl100FClIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 - self.lIl10305lIl.w.UINT16_0
        return
    def lIl100FDlIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 - self.lIl10305lIl.UINT32
        self.lIl10303lIl = self.lIl10303lIl + 1 
        return
    def lIl100FElIl(self):
        if self.lIl102EDlIl: self.lIl100CElIl("FncC_SUB_I16")
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 - self.lIl10305lIl.i.INT16_0
        return
    def lIl100FFlIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 - self.lIl10305lIl.INT32
        self.lIl10303lIl = self.lIl10303lIl + 1 
        return
    def lIl10100lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 - self.lIl10305lIl.FLOAT_0
        self.lIl10303lIl = self.lIl10303lIl + 1 
        return
    
    def lIl10101lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 * self.lIl10305lIl.b.UINT8_0
        return
    def lIl10102lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 * self.lIl10305lIl.w.UINT16_0
        return
    def lIl10103lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 * self.lIl10305lIl.UINT32
        self.lIl10303lIl = self.lIl10303lIl + 1 
        return
    def lIl10104lIl(self):
        if self.lIl102EDlIl: self.lIl100CElIl("FncC_MUL_I16")
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 * self.lIl10305lIl.i.INT16_0
        return
    def lIl10105lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 * self.lIl10305lIl.INT32
        self.lIl10303lIl = self.lIl10303lIl + 1 
        return
    def lIl10106lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 * self.lIl10305lIl.FLOAT_0
        self.lIl10303lIl = self.lIl10303lIl + 1 
        return
    
    def lIl10107lIl(self):
        if self.lIl10305lIl.b.UINT8_0==0:
            self.lIl102FFlIl.FLOAT_0=255.0
        else: self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 / self.lIl10305lIl.b.UINT8_0
        return
    def lIl10108lIl(self):
        if self.lIl10305lIl.w.UINT16_0==0:
            self.lIl102FFlIl.FLOAT_0=65535.0
        else: self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 / self.lIl10305lIl.w.UINT16_0
        return
    def lIl10109lIl(self):
        if self.lIl10305lIl.UINT32==0:
            self.lIl102FFlIl.FLOAT_0=4294967295.0
        else: self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 / self.lIl10305lIl.UINT32
        self.lIl10303lIl = self.lIl10303lIl + 1 
        return
    def lIl1010AlIl(self):
        if self.lIl102EDlIl: self.lIl100CElIl("FncC_DIV_I16")
        if self.lIl10305lIl.i.INT16_0==0:
            self.lIl102FFlIl.FLOAT_0=32767.0
        else:self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 / self.lIl10305lIl.i.INT16_0
        return
    def lIl1010BlIl(self):
        if self.lIl10305lIl.INT32==0:
            self.lIl102FFlIl.FLOAT_0=2147483647.0
        else: self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 / self.lIl10305lIl.INT32
        self.lIl10303lIl = self.lIl10303lIl + 1 
        return
    def lIl1010ClIl(self):
        if abs(self.lIl10305lIl.FLOAT_0) < 0.000001:
            self.lIl102FFlIl.FLOAT_0=3.402823466e38
        else: self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 / self.lIl10305lIl.FLOAT_0
        self.lIl10303lIl = self.lIl10303lIl + 1 
        return
    
    def lIl1010DlIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 + self.lIl102E9lIl.lIl10027lIl(self.lIl1030DlIl)
        return
    def lIl1010ElIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 + self.lIl102E9lIl.lIl1001FlIl(self.lIl1030DlIl)
        return
    def lIl1010FlIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 + self.lIl102E9lIl.lIl10025lIl(self.lIl1030DlIl)
        return
    def lIl10110lIl(self):
        if self.lIl102EDlIl: self.lIl100CElIl("FncC_ADD_D_I16")
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 + self.lIl102E9lIl.lIl1001BlIl(self.lIl1030DlIl)
        return
    def lIl10111lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 + self.lIl102E9lIl.lIl1001DlIl(self.lIl1030DlIl)
        return
    def lIl10112lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 + self.lIl102E9lIl.lIl10019lIl(self.lIl1030DlIl)
        return
    
    def lIl10113lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 - self.lIl102E9lIl.lIl10027lIl(self.lIl1030DlIl)
        return
    def lIl10114lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 - self.lIl102E9lIl.lIl1001FlIl(self.lIl1030DlIl)
        return
    def lIl10115lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 - self.lIl102E9lIl.lIl10025lIl(self.lIl1030DlIl)
        return
    def lIl10116lIl(self):
        if self.lIl102EDlIl: self.lIl100CElIl("FncC_SUB_D_I16")
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 - self.lIl102E9lIl.lIl1001BlIl(self.lIl1030DlIl)
        return
    def lIl10117lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 - self.lIl102E9lIl.lIl1001DlIl(self.lIl1030DlIl)
        return
    def lIl10118lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 - self.lIl102E9lIl.lIl10019lIl(self.lIl1030DlIl)
        return
    
    def lIl10119lIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 * self.lIl102E9lIl.lIl10027lIl(self.lIl1030DlIl)
        return
    def lIl1011AlIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 * self.lIl102E9lIl.lIl1001FlIl(self.lIl1030DlIl)
        return
    def lIl1011BlIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 * self.lIl102E9lIl.lIl10025lIl(self.lIl1030DlIl)
        return
    def lIl1011ClIl(self):
        if self.lIl102EDlIl: self.lIl100CElIl("FncC_MUL_D_I16")
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 * self.lIl102E9lIl.lIl1001BlIl(self.lIl1030DlIl)
        return
    def lIl1011DlIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 * self.lIl102E9lIl.lIl1001DlIl(self.lIl1030DlIl)
        return
    def lIl1011ElIl(self):
        self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 * self.lIl102E9lIl.lIl10019lIl(self.lIl1030DlIl)
        return
    
    def lIl1011FlIl(self):
        if self.lIl102E9lIl.lIl10027lIl(self.lIl1030DlIl)==0:
            self.lIl102FFlIl.FLOAT_0=255.0
        else:self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 / self.lIl102E9lIl.lIl10027lIl(self.lIl1030DlIl)
        return
    def lIl10120lIl(self):
        if self.lIl102E9lIl.lIl1001FlIl(self.lIl1030DlIl)==0:
            self.lIl102FFlIl.FLOAT_0=65535.0
        else:self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 / self.lIl102E9lIl.lIl1001FlIl(self.lIl1030DlIl)
        return
    def lIl10121lIl(self):
        if self.lIl102E9lIl.lIl10025lIl(self.lIl1030DlIl)==0:
            self.lIl102FFlIl.FLOAT_0=4294967295.0
        else:self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 / self.lIl102E9lIl.lIl10025lIl(self.lIl1030DlIl)
        return
    def lIl10122lIl(self):
        if self.lIl102EDlIl: self.lIl100CElIl("FncC_DIV_D_I16")
        if self.lIl102E9lIl.lIl1001BlIl(self.lIl1030DlIl)==0:
            self.lIl102FFlIl.FLOAT_0=32767.0
        else:self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 / self.lIl102E9lIl.lIl1001BlIl(self.lIl1030DlIl)
        return
    def lIl10123lIl(self):
        if self.lIl102E9lIl.lIl1001DlIl(self.lIl1030DlIl)==0:
            self.lIl102FFlIl.FLOAT_0=2147483647.0
        else:self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 / self.lIl102E9lIl.lIl1001DlIl(self.lIl1030DlIl)
        return
    def lIl10124lIl(self):
        if abs(self.lIl102E9lIl.lIl10019lIl(self.lIl1030DlIl))<0.0000001:
            self.lIl102FFlIl.FLOAT_0=3.402823466e38
        else:self.lIl102FFlIl.FLOAT_0 = self.lIl102FFlIl.FLOAT_0 / self.lIl102E9lIl.lIl10019lIl(self.lIl1030DlIl)
        return
    
    def lIl10125lIl(self):
        self.lIl10307lIl[self.lIl10308lIl].lIl102E1lIl = (self.lIl10309lIl == False)
        self.lIl10307lIl[self.lIl10308lIl].lIl102E0lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl10308lIl+=1
        return
    def lIl10126lIl(self):
        self.lIl10308lIl-=1
        if self.lIl10307lIl[self.lIl10308lIl].lIl102E1lIl:
            return
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 += self.lIl10307lIl[self.lIl10308lIl].lIl102E0lIl.FLOAT_0
        return
    def lIl10127lIl(self):
        self.lIl10308lIl-=1
        if self.lIl10307lIl[self.lIl10308lIl].lIl102E1lIl:
            return
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 = self.lIl10307lIl[self.lIl10308lIl].lIl102E0lIl.FLOAT_0 -self.lIl102FFlIl.FLOAT_0
        return
    def lIl10128lIl(self):
        self.lIl10308lIl-=1
        if self.lIl10307lIl[self.lIl10308lIl].lIl102E1lIl:
            return
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 *= self.lIl10307lIl[self.lIl10308lIl].lIl102E0lIl.FLOAT_0
        return
    def lIl10129lIl(self):
        self.lIl10308lIl-=1
        if self.lIl10307lIl[self.lIl10308lIl].lIl102E1lIl:
            return
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        if abs(self.lIl102FFlIl.FLOAT_0)<0.000001:
            self.lIl102FFlIl.FLOAT_0=3.402823466e38
        else:self.lIl102FFlIl.FLOAT_0 = self.lIl10307lIl[self.lIl10308lIl].lIl102E0lIl.FLOAT_0 / self.lIl102FFlIl.FLOAT_0
        return
    
    def lIl1012AlIl(self):
        self.lIl10304lIl.b.UINT8_0 = c_ubyte(round(self.lIl102FFlIl.FLOAT_0))
        self.lIl102E9lIl.lIl10035lIl(self.lIl1030DlIl, self.lIl10304lIl.b.UINT8_0)
        return
    def lIl1012BlIl(self):
        if self.lIl102EDlIl: self.lIl100CElIl("FncC_TRANSF_D_INT16")
        self.lIl10304lIl.i.INT16_0 = c_int16(round(self.lIl102FFlIl.FLOAT_0))
        self.lIl102E9lIl.lIl10030lIl(self.lIl1030DlIl, self.lIl10304lIl.w.UINT16_0)
        return
    def lIl1012ClIl(self):
        self.lIl10304lIl.w.UINT16_0 =c_uint16(round(self.lIl102FFlIl.FLOAT_0))
        self.lIl102E9lIl.lIl10030lIl(self.lIl1030DlIl, self.lIl10304lIl.w.UINT16_0)
        return
    def lIl1012DlIl(self):
        self.lIl10304lIl.INT32 =c_int32(round(self.lIl102FFlIl.FLOAT_0))
        self.lIl102E9lIl.lIl1002ClIl(self.lIl1030DlIl, self.lIl10304lIl.UINT32)
        return
    def lIl1012ElIl(self):
        self.lIl10304lIl.UINT32 =c_uint32(round(self.lIl102FFlIl.FLOAT_0))
        self.lIl102E9lIl.lIl1002ClIl(self.lIl1030DlIl, self.lIl10304lIl.UINT32)
        return
    def lIl1012FlIl(self):
        self.lIl102E9lIl.lIl1002ClIl(self.lIl1030DlIl, self.lIl102FFlIl.UINT32)
        return
    
    def lIl10130lIl(self):
        self.lIl10309lIl = True
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 = c_float(self.lIl102E9lIl.lIl10027lIl(self.lIl1030DlIl))
        return
    def lIl10131lIl(self):
        if self.lIl102EDlIl: self.lIl100CElIl("FncC_LOAD_D_INT16")
        self.lIl10309lIl = True
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 = c_float(self.lIl102E9lIl.lIl1001BlIl(self.lIl1030DlIl))
        return
    def lIl10132lIl(self):
        self.lIl10309lIl = True
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 = c_float(self.lIl102E9lIl.lIl1001FlIl(self.lIl1030DlIl))
        return
    def lIl10133lIl(self):
        self.lIl10309lIl = True
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 = c_float(self.lIl102E9lIl.lIl1001DlIl(self.lIl1030DlIl))
        return
    def lIl10134lIl(self):
        self.lIl10309lIl = True
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 = c_float(self.lIl102E9lIl.lIl10025lIl(self.lIl1030DlIl))
        return
    def lIl10135lIl(self):
        self.lIl10309lIl = True
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 = self.lIl102E9lIl.lIl10019lIl(self.lIl1030DlIl)
        return
    
    def lIl10136lIl(self):
        self.lIl10309lIl = True
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 = c_float(self.lIl1030DlIl)
        return
    def lIl10137lIl(self):
        if self.lIl102EDlIl: self.lIl100CElIl("FncC_LOAD_INT16")
        self.lIl10309lIl = True
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 = c_float(c_int16(self.lIl1030DlIl).value)
        return
    def lIl10138lIl(self):
        self.lIl10309lIl = True
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 = c_float(c_uint16(self.lIl1030DlIl).value)
        return
    def lIl10139lIl(self):
        self.lIl10309lIl = True
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 = c_float(self.lIl10305lIl.INT32)
        self.lIl10303lIl = self.lIl10303lIl + 1 
        return
    def lIl1013AlIl(self):
        self.lIl10309lIl = True
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 = c_float(self.lIl10305lIl.UINT32)
        self.lIl10303lIl = self.lIl10303lIl + 1 
        return
    def lIl1013BlIl(self):
        self.lIl10309lIl = True
        self.lIl10300lIl.UINT32 = self.lIl102FFlIl.UINT32
        self.lIl102FFlIl.FLOAT_0 = self.lIl10305lIl.FLOAT_0
        self.lIl10303lIl = self.lIl10303lIl + 1 
        return
    
#
    
    
    def lIl1013ClIl(self, lIl1013DlIl, lIl1013ElIl, lIl1013FlIl, lIl10140lIl):
        lIl10141lIl = 1 << lIl1013FlIl
        if lIl10140lIl:
            lIl1013DlIl[lIl1013ElIl] |= lIl10141lIl 
        else:
            lIl10141lIl=~lIl10141lIl 
            lIl1013DlIl[lIl1013ElIl] &= lIl10141lIl 
    
    def lIl10142lIl(self,lIl10143lIl, lIl10144lIl):
        return (lIl10143lIl & (1 << lIl10144lIl)) != 0


    
    
    def lIl10145lIl(self):
        self.lIl102E4lIl=math.floor((time.time()-self.lIl1030ElIl)*1000)
        return self.lIl102E4lIl

    
    def lIl10146lIl(self,lIl10147lIl, lIl10148lIl, lIl10149lIl):
        try:
            for m2 in range(lIl10149lIl):
                lIl10147lIl[lIl10148lIl[m2]].lIl102A6lIl = True
                if lIl10147lIl[lIl10148lIl[m2]].lIl102BDlIl > 0:
                    self.lIl10146lIl(lIl10147lIl, lIl10147lIl[lIl10148lIl[m2]].lIl102BClIl, lIl10147lIl[lIl10148lIl[m2]].lIl102BDlIl)
        except:
            pass
            

    
    def lIl1014AlIl(self,lIl1014BlIl, lIl1014ClIl, lIl1014DlIl, lIl1014ElIl):
        try:
            lIl1014FlIl = 0
            if lIl1014ClIl > 0 and lIl1014DlIl > 0:

                if lIl1014ClIl < self.lIl10145lIl():
                    lIl1014FlIl = 100
                else:
                    lIl10151lIl = lIl1014ClIl - self.lIl10145lIl()
                    lIl10152lIl = lIl10151lIl / lIl1014DlIl * 100.0 
                    lIl1014FlIl = int(lIl10152lIl)
                    if lIl1014FlIl<0: lIl1014FlIl=0
            lIl1014BlIl[lIl1014ElIl] = lIl1014FlIl
            lIl1014ElIl+=1
            return lIl1014ElIl
        except:
            pass

    
    def lIl10154lIl(self,lIl10155lIl, lIl10156lIl, lIl10157lIl):
        try:
            lIl10158lIl = False
            if lIl10155lIl == None:
                if lIl10157lIl:
                    lIl10158lIl = lIl10156lIl
                return lIl10158lIl

            
            if lIl10155lIl.lIl10294lIl:
                lIl10155lIl.lIl10296lIl = lIl10155lIl.lIl10298lIl
                self.lIl10165lIl(lIl10155lIl.lIl1029FlIl, True)
                lIl10155lIl.lIl10298lIl = self.lIl102FDlIl
                if lIl10155lIl.lIl10298lIl == False:
                    
                    if lIl10155lIl.lIl10296lIl: 
                        lIl10155lIl.lIl102A1lIl = self.lIl10145lIl() + lIl10155lIl.lIl102A3lIl
                        lIl10155lIl.lIl1029ClIl = False
                    
                    if lIl10155lIl.lIl102A1lIl == 0 or (lIl10155lIl.lIl102A1lIl > 0 and self.lIl10145lIl() > lIl10155lIl.lIl102A1lIl):
                        lIl10155lIl.lIl102A1lIl = 0
                        lIl10155lIl.lIl1029ClIl = True
                else:
                    lIl10155lIl.lIl102A1lIl = 0
            
            
            if lIl10155lIl.lIl10293lIl:
                lIl10155lIl.lIl10295lIl = lIl10155lIl.lIl10297lIl
                self.lIl10165lIl(lIl10155lIl.lIl1029ElIl, True)
                lIl10155lIl.lIl10297lIl = self.lIl102FDlIl
                if lIl10155lIl.lIl10297lIl:
                    
                    if lIl10155lIl.lIl10295lIl == False: 
                        lIl10155lIl.lIl102A0lIl = self.lIl10145lIl() + lIl10155lIl.lIl102A2lIl
                        lIl10155lIl.lIl1029BlIl = False
                    
                    if lIl10155lIl.lIl102A0lIl == 0 or (lIl10155lIl.lIl102A0lIl > 0 and self.lIl10145lIl() > lIl10155lIl.lIl102A0lIl):
                        lIl10155lIl.lIl102A0lIl = 0
                        lIl10155lIl.lIl1029BlIl = True
                else: 
                    lIl10155lIl.lIl102A0lIl = 0

            lIl1015AlIl = lIl10155lIl.lIl1029BlIl and lIl10155lIl.lIl10297lIl 
                                                                        
            lIl1015BlIl = lIl10155lIl.lIl102A1lIl != 0 or lIl10155lIl.lIl10298lIl

            if lIl10157lIl:
                lIl10158lIl = lIl10156lIl
            
            if lIl10155lIl.lIl10293lIl and lIl10155lIl.lIl10294lIl and lIl10155lIl.lIl1029ElIl == lIl10155lIl.lIl1029FlIl and lIl10157lIl == False:
                lIl10158lIl = lIl1015AlIl or (lIl10155lIl.lIl1029BlIl and lIl1015BlIl)
                return lIl10158lIl

            if lIl10155lIl.lIl10293lIl:
                if lIl10155lIl.lIl1029DlIl:
                    lIl1015AlIl = not lIl1015AlIl 
                if lIl10155lIl.lIl10299lIl == False:
                    lIl10158lIl = lIl1015AlIl and (lIl10158lIl or lIl10157lIl == False)
                if lIl10155lIl.lIl10299lIl:
                    lIl10158lIl = lIl1015AlIl or lIl10158lIl

            if lIl10155lIl.lIl10294lIl:
                if lIl10155lIl.lIl10293lIl == False:
                    if lIl10155lIl.lIl1029AlIl == False:
                        lIl10158lIl = (lIl10158lIl or lIl10157lIl == False) and lIl1015BlIl
                    if lIl10155lIl.lIl1029AlIl:
                        lIl10158lIl = lIl10158lIl or lIl1015BlIl
                else: 
                    if lIl10155lIl.lIl1029AlIl == False:
                        lIl10158lIl = lIl10158lIl and lIl1015BlIl
                    if lIl10155lIl.lIl1029AlIl:
                        lIl10158lIl = lIl10158lIl or lIl1015BlIl

            return lIl10158lIl	    
        except:
            pass
    
    
    def lIl10165lIl(self, lIl10166lIl, lIl10167lIl):
        try:
            self.lIl102FElIl = True
            self.lIl102FDlIl = False
            self.lIl102FFlIl.UINT32 = 0
            self.lIl10300lIl.UINT32 = 0
            self.lIl10303lIl = lIl10166lIl
            self.lIl10304lIl=Any32()
            self.value=Any32()
            self.lIl10308lIl = 0
            self.lIl10309lIl = False
            self.lIl1030AlIl = False
            self.lIl1030ClIl = 0
            self.lIl1030DlIl = 0

            if lIl10166lIl == 0: 
                return

            if lIl10167lIl == False: 
                self.lIl102FDlIl = False
                self.lIl102FElIl = False

            if self.lIl102F7lIl[lIl10166lIl + 2] == 0:
                if self.lIl102F7lIl[lIl10166lIl] >> 8 == lIl101E1lIl.lIl1020FlIl:
                    self.lIl102FDlIl = True
                    return

                if self.lIl102F7lIl[lIl10166lIl] >> 8 == lIl101E1lIl.lIl10211lIl:
                    lIl10168lIl = self.lIl102F7lIl[lIl10166lIl] & 0x00FF
                    lIl10169lIl = self.lIl102F7lIl[lIl10166lIl + 1]
                    self.lIl102FDlIl = self.lIl102E9lIl.lIl10016lIl(lIl10169lIl,lIl10168lIl)
                    return
            
                if self.lIl102F7lIl[lIl10166lIl] >> 8 == lIl101E1lIl.lIl10212lIl:
                    lIl10168lIl = self.lIl102F7lIl[lIl10166lIl] & 0x00FF
                    lIl10169lIl = self.lIl102F7lIl[lIl10166lIl + 1]
                    self.lIl102FDlIl = not self.lIl102E9lIl.lIl10016lIl(lIl10169lIl, lIl10168lIl)
                    return
            

            while not self.lIl1030AlIl:

                self.lIl10304lIl.w.UINT16_0 = self.lIl102F7lIl[self.lIl10303lIl]
                self.lIl10304lIl.w.UINT16_1 = self.lIl102F7lIl[self.lIl10303lIl+1]
                
                lIl1016ClIl = self.lIl10304lIl.b.UINT8_1
                if lIl1016ClIl == lIl101E1lIl.lIl10201lIl: 
                    break

                
                
                
                self.lIl10305lIl.w.UINT16_0 = self.lIl102F7lIl[self.lIl10303lIl + 1] 
                self.lIl10305lIl.w.UINT16_1 = self.lIl102F7lIl[self.lIl10303lIl + 2] 
                
                self.lIl1030ClIl = self.lIl10304lIl.b.UINT8_0
                self.lIl1030DlIl = self.lIl10304lIl.w.UINT16_1


                self.lIl102FClIl+=1
                
                
                
                
                
                
                
                
                
                lIl1016DlIl = self.lIl1030BlIl.get(lIl1016ClIl, lambda: "?")
                if lIl1016DlIl=="?":
                    self.GrafcetEngineStatus.lIl102DBlIl = 1000
                    self.GrafcetEngineStatus.lIl102DClIl = lIl1016ClIl 
                else:
                    
                    lIl1016DlIl()

                self.lIl10303lIl +=2
            
        except:
            pass
        return

    
    def lIl1016ElIl(self,lIl1016FlIl, lIl10170lIl, lIl10171lIl):
        try:
            lIl10172lIl=0
            lIl10173lIl=0
            lIl10174lIl = True
            lIl10175lIl = False
            lIl10176lIl=False
            lIl10177lIl = lIl1016FlIl.lIl102A6lIl
            
            lIl10178lIl = (lIl10170lIl.lIl102A6lIl or lIl10170lIl.lIl102B1lIl) and not lIl10170lIl.lIl102B0lIl
            lIl10179lIl = not lIl10170lIl.lIl102A6lIl and lIl10170lIl.lIl102B0lIl 

            if lIl1016FlIl.lIl102C8lIl == lIl101E1lIl.lIl101FClIl or lIl1016FlIl.lIl102C8lIl == lIl101E1lIl.lIl101F8lIl:
                lIl10175lIl = True
            
            
            if lIl1016FlIl.lIl102C8lIl==lIl101E1lIl.lIl101F7lIl:
                if lIl10178lIl:            
                    lIl10176lIl = True
                lIl10177lIl = lIl10176lIl
            
            elif lIl1016FlIl.lIl102C8lIl==lIl101E1lIl.lIl101F9lIl:   
                if lIl10179lIl:
                    lIl10176lIl = True
                lIl10177lIl = lIl10176lIl
            
            elif lIl1016FlIl.lIl102C8lIl==lIl101E1lIl.lIl101F8lIl or lIl1016FlIl.lIl102C8lIl==lIl101E1lIl.lIl101FAlIl:   
                if (lIl1016FlIl.lIl102C8lIl == lIl101E1lIl.lIl101F8lIl and lIl10170lIl.lIl102A6lIl and lIl10170lIl.lIl102B0lIl): 
                    lIl10176lIl = True
                lIl1016FlIl.lIl102A5lIl = lIl1016FlIl.lIl102A4lIl
                lIl10180lIl = True
                
                if (lIl1016FlIl.lIl102CElIl > 0):
                    lIl10180lIl = False
                    self.lIl10165lIl(lIl1016FlIl.lIl102CElIl, True)
                    lIl1016FlIl.lIl102A4lIl = self.lIl102FDlIl						
                    lIl10177lIl = self.lIl10154lIl(lIl1016FlIl.lIl102A9lIl, lIl1016FlIl.lIl102A4lIl, True) 
                else:
                    if (lIl1016FlIl.lIl102A9lIl != None and (lIl1016FlIl.lIl102A9lIl.lIl10293lIl or lIl1016FlIl.lIl102A9lIl.lIl10294lIl)): 
                        lIl10180lIl = False
                        lIl1016FlIl.lIl102A4lIl = False							
                        lIl10177lIl = self.lIl10154lIl(lIl1016FlIl.lIl102A9lIl, False, False) 
                    else:                
                        lIl1016FlIl.lIl102A4lIl = True 
                        lIl10177lIl = True
                    
                if (lIl1016FlIl.lIl102C8lIl == lIl101E1lIl.lIl101FAlIl and lIl10170lIl.lIl102A6lIl and lIl10177lIl and
                    (not lIl1016FlIl.lIl102A6lIl or lIl10180lIl)): 
                    lIl10176lIl = True

                if (lIl1016FlIl.lIl102C8lIl == lIl101E1lIl.lIl101F8lIl and not lIl10170lIl.lIl102A6lIl):
                    lIl10177lIl = False
                    lIl10176lIl = True
                lIl10174lIl = lIl10177lIl 
            
            elif lIl1016FlIl.lIl102C8lIl==lIl101E1lIl.lIl101FBlIl:   
                lIl10176lIl = lIl10170lIl.lIl102A6lIl and lIl10170lIl.lIl102B0lIl 
                lIl10177lIl = lIl10176lIl					   
            
            elif lIl1016FlIl.lIl102C8lIl==lIl101E1lIl.lIl101FClIl:   
                if ((lIl10170lIl.lIl102A6lIl and lIl10170lIl.lIl102B0lIl) or (not lIl10170lIl.lIl102A6lIl and not lIl10170lIl.lIl102B0lIl)): 
                    lIl10176lIl = True														  
                lIl10177lIl = lIl10170lIl.lIl102A6lIl and lIl10170lIl.lIl102B0lIl								  
                lIl1016FlIl.lIl102A4lIl = lIl10177lIl; 

            lIl1016FlIl.lIl102A6lIl = lIl10177lIl

            
            
            if (lIl1016FlIl.lIl102C8lIl == lIl101E1lIl.lIl101FBlIl):
                if (lIl10178lIl or (lIl10170lIl.lIl102A6lIl and lIl10170lIl.lIl102B0lIl)): 
                    
                    if (lIl1016FlIl.lIl102C6lIl):
                        for lIl10172lIl in range(self.GrafcetEngineStatus.lIl102D0lIl):
                            if lIl1016FlIl.lIl102B5lIl == lIl10171lIl[lIl10172lIl].lIl102B5lIl:
                                if lIl1016FlIl.lIl102C5lIl == False:
                                    lIl10171lIl[lIl10172lIl].lIl102A6lIl = False
                                    lIl10171lIl[lIl10172lIl].lIl102B2lIl = False 
                                lIl10171lIl[lIl10172lIl].lIl102B3lIl = True
                    
                    
                    for lIl10172lIl in range(lIl1016FlIl.lIl102BDlIl):
                        lIl10173lIl = lIl1016FlIl.lIl102BClIl[lIl10172lIl]
                        if (not lIl1016FlIl.lIl102C5lIl):
                            lIl10171lIl[lIl10173lIl].lIl102A6lIl = True
                        lIl10171lIl[lIl10173lIl].lIl102B3lIl = True
                    
                if (lIl10179lIl or lIl10170lIl.lIl102A6lIl == False and lIl10178lIl): 
                    if (lIl1016FlIl.lIl102BDlIl > 0):
                        for lIl10172lIl in range(lIl1016FlIl.lIl102BDlIl):
                            lIl10173lIl = lIl1016FlIl.lIl102BClIl[lIl10172lIl]
                            lIl10171lIl[lIl10173lIl].lIl102B3lIl = False
                    
                    
                    if lIl1016FlIl.lIl102C6lIl:
                        for lIl10172lIl in range(self.GrafcetEngineStatus.lIl102D0lIl):
                            if lIl1016FlIl.lIl102B5lIl == lIl10171lIl[lIl10172lIl].lIl102B5lIl:
                                lIl10171lIl[lIl10172lIl].lIl102B3lIl = False
                            
                return 
            
            
            if lIl10176lIl == False:        
                return

            
            ''' old code, is replaced by the following code
            if lIl10175lIl and lIl10170lIl.lIl102A6lIl == False:
                for lIl10172lIl in range(lIl1016FlIl.lIl102BDlIl):
                    lIl10173lIl = lIl1016FlIl.lIl102BClIl[lIl10172lIl]
                    if lIl10171lIl[lIl10173lIl].lIl102A6lIl:
                        return 
            '''    
            
            
            if lIl10175lIl and lIl1016FlIl.lIl102A6lIl==False:
                
                lIl10191lIl = lIl1016FlIl.lIl102BDlIl
                for lIl10172lIl in range(lIl10191lIl):
                    lIl10192lIl = lIl1016FlIl.lIl102BClIl[lIl10172lIl]
                    if self.lIl102F5lIl[lIl10192lIl].lIl102A4lIl:
                        return; 
            
            
            if lIl10175lIl: 
                lIl10193lIl = self.lIl102F7lIl[lIl1016FlIl.lIl102CClIl + 2] & 0x00FF
                lIl10194lIl = self.lIl102F7lIl[lIl1016FlIl.lIl102CClIl + 3]

                if (self.lIl102F7lIl[lIl1016FlIl.lIl102CClIl] >> 8) == lIl101E1lIl.lIl10212lIl:
                    self.lIl102E9lIl.lIl10038lIl(lIl10194lIl, lIl10193lIl, not(lIl10170lIl.lIl102A6lIl and lIl10174lIl))
                else:
                    self.lIl102E9lIl.lIl10038lIl(lIl10194lIl, lIl10193lIl, lIl10170lIl.lIl102A6lIl and lIl10174lIl)
            else:
                
                self.lIl10165lIl(lIl1016FlIl.lIl102CClIl, lIl10174lIl) 
        except:
            pass
    

    
    
    def lIl10195lIl(self):
        lIl10196lIl=datetime.datetime.now()
        if (self.lIl102F9lIl.lIl10280lIl.lIl10281lIl>0):
            self.lIl102E9lIl.lIl10030lIl(self.lIl102F9lIl.lIl10280lIl.lIl10281lIl, lIl10196lIl.year)
        if (self.lIl102F9lIl.lIl10280lIl.lIl10282lIl>0):
            self.lIl102E9lIl.lIl10035lIl(self.lIl102F9lIl.lIl10280lIl.lIl10282lIl, lIl10196lIl.month)
        if (self.lIl102F9lIl.lIl10280lIl.lIl10283lIl>0):
            self.lIl102E9lIl.lIl10035lIl(self.lIl102F9lIl.lIl10280lIl.lIl10283lIl, lIl10196lIl.day)
        if (self.lIl102F9lIl.lIl10280lIl.lIl10284lIl>0):
            self.lIl102E9lIl.lIl10035lIl(self.lIl102F9lIl.lIl10280lIl.lIl10284lIl, lIl10196lIl.hour)
        
        if (self.lIl102F9lIl.lIl10280lIl.lIl10285lIl>0):
            self.lIl102E9lIl.lIl10035lIl(self.lIl102F9lIl.lIl10280lIl.lIl10285lIl, lIl10196lIl.minute)
        
        if (self.lIl102F9lIl.lIl10280lIl.lIl10286lIl>0):
            self.lIl102E9lIl.lIl10035lIl(self.lIl102F9lIl.lIl10280lIl.lIl10286lIl, lIl10196lIl.second)

        if (self.lIl102F9lIl.lIl10280lIl.lIl10287lIl>0):
            self.lIl102E9lIl.lIl10030lIl(self.lIl102F9lIl.lIl10280lIl.lIl10287lIl, round(lIl10196lIl.microsecond/1000))
        
        if (self.lIl102F9lIl.lIl10280lIl.lIl10288lIl>0):
            self.lIl102E9lIl.lIl10030lIl(self.lIl102F9lIl.lIl10280lIl.lIl10288lIl, math.floor(self.GrafcetEngineStatus.PlcCyclicTimeMs))
        
        if (self.lIl102F9lIl.lIl10280lIl.lIl10289lIl>0):
            self.lIl102E9lIl.lIl10030lIl(self.lIl102F9lIl.lIl10280lIl.lIl10289lIl, self.GrafcetEngineStatus.CyclicCounter)
        
        if (self.lIl102F9lIl.lIl10280lIl.lIl1028AlIl>0):
            self.lIl102E9lIl.lIl1002ClIl(self.lIl102F9lIl.lIl10280lIl.lIl1028AlIl, self.lIl10145lIl())
        
        if (self.lIl102F9lIl.lIl10280lIl.lIl1028BlIl>0):
            self.lIl102E9lIl.lIl10030lIl(self.lIl102F9lIl.lIl10280lIl.lIl1028BlIl, self.GrafcetEngineStatus.Version)
        
        if (self.lIl102F9lIl.lIl10280lIl.lIl1028ClIl>0):
            self.lIl102E9lIl.lIl10030lIl(self.lIl102F9lIl.lIl10280lIl.lIl1028ClIl, self.GrafcetEngineStatus.lIl102D4lIl)
        
        if (self.lIl102F9lIl.lIl10280lIl.lIl1028DlIl>0):
            self.lIl102E9lIl.lIl10038lIl(self.lIl102F9lIl.lIl10280lIl.lIl1028DlIl,self.lIl102F9lIl.lIl10280lIl.lIl1028ElIl, lIl10196lIl.second%2==0)
        
        self.lIl102F3lIl=not self.lIl102F3lIl
        if (self.lIl102F9lIl.lIl10280lIl.lIl1028FlIl>0):
            self.lIl102E9lIl.lIl10038lIl(self.lIl102F9lIl.lIl10280lIl.lIl1028FlIl,self.lIl102F9lIl.lIl10280lIl.lIl10290lIl, self.lIl102F3lIl)
        
        if (self.lIl102F9lIl.lIl10280lIl.lIl10291lIl>0):
            lIl10197lIl=self.lIl102E9lIl.lIl10016lIl(self.lIl102F9lIl.lIl10280lIl.lIl10291lIl,self.lIl102F9lIl.lIl10280lIl.lIl10292lIl)
            if lIl10197lIl: self.GrafcetEngineStatus.lIl102D8lIl=True
    

    
    
    def GrafcetCyclic(self):
        try:
            self.lIl101CClIl()
            self.lIl10195lIl()

            if self.lIl102F1lIl==False: 
                self.lIl102E6lIl.loop_start()
                self.lIl102F1lIl=True 

            if self.lIl102F2lIl==False:
               self.lIl10069lIl()
               self.lIl102F2lIl=True

            if time.time()-self.lIl102F0lIl>0.5: 
                self.lIl101DAlIl("EngineStatusStruct", self.GrafcetEngineStatus.lIl10050lIl(self.lIl102F9lIl))
                self.lIl102F0lIl=time.time()

            if time.time()-self.lIl102EFlIl>0.02: 
                if self.GrafcetEngineStatus.lIl102D9lIl: self.lIl101DAlIl("MonitoringData", self.lIl102EBlIl[0:self.GrafcetEngineStatus.lIl102D4lIl])
                self.lIl102EFlIl=time.time()
            
            
            lIl10198lIl=0
            lIl10199lIl=0
            self.lIl102FClIl=0
            self.lIl102E7lIl = self.lIl102E2lIl == 0 or self.GrafcetEngineStatus.lIl102D8lIl or self.lIl102E8lIl
            
            self.lIl102E2lIl = self.lIl10145lIl()
            
            
            if self.GrafcetEngineStatus.CyclicCounter %10 == 0:
                self.GrafcetEngineStatus.PlcCyclicTimeMs = (self.lIl10145lIl() - self.lIl102E3lIl) / 10
                self.lIl102E3lIl = self.lIl10145lIl()
            
            if self.GrafcetEngineStatus.ActiveCounter==0xFFFF:self.GrafcetEngineStatus.ActiveCounter=0
            self.GrafcetEngineStatus.ActiveCounter+=1

            if self.GrafcetEngineStatus.GrafcetRun ==False:
                
                return
            
            if self.GrafcetEngineStatus.CyclicCounter==0xFFFF:self.GrafcetEngineStatus.CyclicCounter=0
            self.GrafcetEngineStatus.CyclicCounter+=1
            

            
            

            if self.lIl102E7lIl:
                
                for addr in range(self.lIl102F9lIl.lIl10278lIl):
                    self.lIl102E9lIl.lIl10003lIl()

                
                for i in range(self.GrafcetEngineStatus.lIl102D0lIl):
                    self.lIl102F4lIl[i].lIl102A6lIl=False

            
            self.lIl101AClIl(self.GrafcetEngineStatus.lIl102D0lIl, self.lIl102E7lIl, self.lIl102F4lIl, self.lIl102F6lIl, self.lIl102F5lIl)

            
            self.GrafcetEngineStatus.lIl102D8lIl=False

            
            self.lIl102EAlIl.lIl1003DlIl(self.lIl102E9lIl, self.lIl102F9lIl.lIl10278lIl)
            
            
            
            lIl10198lIl=self.lIl102F9lIl.lIl10277lIl
            lIl10199lIl=0
            lIl1019ClIl=None
            for lIl1019ClIl in self.lIl102F4lIl:
                self.lIl102E9lIl.lIl10038lIl(lIl10198lIl, lIl10199lIl, lIl1019ClIl.lIl102A6lIl)
                lIl10199lIl+=1
                if lIl10199lIl ==8:
                    lIl10199lIl=0
                    lIl10198lIl+=1
                

            
            
            if self.GrafcetEngineStatus.lIl102D9lIl:
                lIl10198lIl=0
                lIl10199lIl=0        
                
                for lIl1019ClIl in self.lIl102F4lIl:
                    
                    self.lIl1013ClIl(self.lIl102EBlIl, lIl10198lIl, lIl10199lIl, lIl1019ClIl.lIl102A6lIl)
                    lIl10199lIl+=1
                    if lIl10199lIl ==8:
                        lIl10199lIl=0
                        lIl10198lIl+=1
                
                for t in self.lIl102F6lIl:
                    self.lIl1013ClIl(self.lIl102EBlIl, lIl10198lIl, lIl10199lIl, t.lIl102A6lIl)
                    lIl10199lIl+=1
                    if lIl10199lIl ==8:
                        lIl10199lIl=0
                        lIl10198lIl+=1
                
                for a in self.lIl102F5lIl:
                    self.lIl1013ClIl(self.lIl102EBlIl, lIl10198lIl, lIl10199lIl, a.lIl102A6lIl)
                    lIl10199lIl+=1
                    if lIl10199lIl ==8:
                        lIl10199lIl=0
                        lIl10198lIl+=1        
                lIl10198lIl+=1
                
                for t in self.lIl102F6lIl:
                    if t.lIl102A9lIl==None:continue
                    if t.lIl102A9lIl.lIl10293lIl:
                        lIl10198lIl=self.lIl1014AlIl(self.lIl102EBlIl, t.lIl102A9lIl.lIl102A0lIl,t.lIl102A9lIl.lIl102A2lIl, lIl10198lIl)
                    if t.lIl102A9lIl.lIl10294lIl:
                        lIl10198lIl=self.lIl1014AlIl(self.lIl102EBlIl, t.lIl102A9lIl.lIl102A1lIl,t.lIl102A9lIl.lIl102A3lIl, lIl10198lIl)
                
                for a in self.lIl102F5lIl:
                    if a.lIl102A9lIl==None:continue
                    if a.lIl102A9lIl.lIl10293lIl:
                        lIl10198lIl=self.lIl1014AlIl(self.lIl102EBlIl, a.lIl102A9lIl.lIl102A0lIl,a.lIl102A9lIl.lIl102A2lIl, lIl10198lIl)
                    if a.lIl102A9lIl.lIl10294lIl:
                        lIl10198lIl=self.lIl1014AlIl(self.lIl102EBlIl, a.lIl102A9lIl.lIl102A1lIl,a.lIl102A9lIl.lIl102A3lIl, lIl10198lIl)

                self.GrafcetEngineStatus.lIl102D4lIl = lIl10198lIl
        
        except:
            pass

    
    
    def lIl101A7lIl(self,lIl101A8lIl, lIl101A9lIl):
        try:
            if lIl101A9lIl.__len__() ==0: return
            for i2 in range(self.GrafcetEngineStatus.lIl102D0lIl):
                lIl101AAlIl = self.lIl102F4lIl[i2]
                for i2 in range(lIl101AAlIl.lIl102B9lIl):
                    lIl101ABlIl = lIl101AAlIl.lIl102B8lIl[i2]
                    if lIl101A9lIl[lIl101ABlIl].lIl102A8lIl==False and lIl101A8lIl==False and lIl101AAlIl.lIl102A6lIl==False and lIl101A9lIl[lIl101ABlIl].lIl102A9lIl==None:
                        lIl101A9lIl[lIl101ABlIl].lIl102A4lIl = False
                        lIl101A9lIl[lIl101ABlIl].lIl102A5lIl = False
                        lIl101A9lIl[lIl101ABlIl].lIl102A6lIl = False
                        if lIl101A9lIl[lIl101ABlIl].lIl102A9lIl != None:
                            lIl101A9lIl[lIl101ABlIl].lIl102A9lIl.lIl10297lIl = False
                            lIl101A9lIl[lIl101ABlIl].lIl102A9lIl.lIl10295lIl = False
                            lIl101A9lIl[lIl101ABlIl].lIl102A9lIl.lIl10298lIl = False
                            lIl101A9lIl[lIl101ABlIl].lIl102A9lIl.lIl10296lIl = False
                        
                        continue
                    
                    lIl101A9lIl[lIl101ABlIl].lIl102A5lIl = lIl101A9lIl[lIl101ABlIl].lIl102A4lIl
                    
                    if lIl101A9lIl[lIl101ABlIl].lIl102AElIl > 0:
                        self.lIl10165lIl(lIl101A9lIl[lIl101ABlIl].lIl102AElIl, True)
                        
                        lIl101A9lIl[lIl101ABlIl].lIl102A4lIl = self.lIl102FDlIl
                    else: 
                        lIl101A9lIl[lIl101ABlIl].lIl102A4lIl = False

                    lIl101A9lIl[lIl101ABlIl].lIl102A6lIl = self.lIl10154lIl(lIl101A9lIl[lIl101ABlIl].lIl102A9lIl, lIl101A9lIl[lIl101ABlIl].lIl102A4lIl, lIl101A9lIl[lIl101ABlIl].lIl102AElIl > 0)
        except:            
            pass
    


    
    
    def lIl101AClIl(self,lIl101ADlIl, lIl101AElIl, lIl101AFlIl, lIl101B0lIl, lIl101B1lIl):
        try:
            lIl101B2lIl=0
            lIl101B3lIl=False
            lIl101B4lIl=0
            lIl101B5lIl=0
            lIl101B6lIl=0
            self.lIl102EElIl=True

            if lIl101ADlIl==0: return 

            
            if lIl101AElIl:
                self.lIl102E8lIl=False
                
                self.GrafcetEngineStatus.lIl102DBlIl = 0
                self.GrafcetEngineStatus.lIl102DClIl = 0
                
                self.lIl102E5lIl = 0
                for s in range(self.GrafcetEngineStatus.lIl102D0lIl):
                    lIl101AFlIl[s].lIl102B2lIl = False
                    lIl101AFlIl[s].lIl102B0lIl = False
                    lIl101AFlIl[s].lIl102B1lIl = False
                    lIl101AFlIl[s].lIl102A6lIl = (lIl101AFlIl[s].lIl102B7lIl == lIl101E1lIl.lIl101FDlIl)
                    
                
                
                lIl101B4lIl = self.lIl102F9lIl.lIl10277lIl
                lIl101B5lIl = 0
                lIl101B9lIl=None
                for lIl101B9lIl in lIl101AFlIl:
                    self.lIl102E9lIl.lIl10038lIl(lIl101B4lIl, lIl101B5lIl, lIl101B9lIl.lIl102A6lIl)
                    lIl101B5lIl+=1
                    if lIl101B5lIl == 8:
                        lIl101B5lIl = 0
                        lIl101B4lIl+=1
                
                
                self.lIl101A7lIl(True, lIl101B0lIl)
            
            
            if self.lIl102E5lIl >= lIl101ADlIl: 
                self.lIl102E5lIl = 0

            
            
            for lIl101B9lIl in lIl101AFlIl:
                
                if lIl101B9lIl.lIl102B4lIl and lIl101AFlIl[lIl101B9lIl.lIl102B6lIl].lIl102A6lIl == False:
                    lIl101B9lIl.lIl102A6lIl = False
                
                if lIl101B9lIl.lIl102A6lIl: 
                    lIl101B9lIl.lIl102B1lIl = True
                    

            
            for self.lIl102E5lIl in range(lIl101ADlIl):
                
                if lIl101AFlIl[self.lIl102E5lIl].lIl102B1lIl:
                    for t in range(lIl101AFlIl[self.lIl102E5lIl].lIl102B9lIl):
                        lIl101B3lIl = lIl101B0lIl[lIl101AFlIl[self.lIl102E5lIl].lIl102B8lIl[t]].lIl102A6lIl
                        if lIl101B3lIl:
                            
                            for m in range(lIl101AFlIl[self.lIl102E5lIl].lIl102C1lIl):
                                lIl101B2lIl = lIl101AFlIl[self.lIl102E5lIl].lIl102C0lIl[m]
                                if lIl101AFlIl[lIl101B2lIl].lIl102B1lIl == False:
                                    lIl101B3lIl = False
                                    break
                            

                            
                            if lIl101B3lIl:
                                for m in range(lIl101B0lIl[lIl101AFlIl[self.lIl102E5lIl].lIl102B8lIl[t]].lIl102ADlIl):
                                    lIl101B2lIl = lIl101B0lIl[lIl101AFlIl[self.lIl102E5lIl].lIl102B8lIl[t]].lIl102AClIl[m]
                                    if lIl101AFlIl[lIl101B2lIl].lIl102B1lIl == False: 
                                        lIl101B3lIl = False
                                        break
                                

                            
                            if lIl101B3lIl and lIl101AFlIl[self.lIl102E5lIl].lIl102B3lIl==False: 
                                if lIl101B0lIl[lIl101AFlIl[self.lIl102E5lIl].lIl102B8lIl[t]].lIl102A7lIl == False:
                                    
                                    
                                    lIl101AFlIl[self.lIl102E5lIl].lIl102A6lIl = False

                                
                                for m in range(lIl101B0lIl[lIl101AFlIl[self.lIl102E5lIl].lIl102B8lIl[t]].lIl102ABlIl):
                                    lIl101B2lIl = lIl101B0lIl[lIl101AFlIl[self.lIl102E5lIl].lIl102B8lIl[t]].lIl102AAlIl[m]
                                    lIl101AFlIl[lIl101B2lIl].lIl102B2lIl = True
                                
                                
                                for m in range(lIl101B0lIl[lIl101AFlIl[self.lIl102E5lIl].lIl102B8lIl[t]].lIl102ADlIl):
                                    lIl101B2lIl = lIl101B0lIl[lIl101AFlIl[self.lIl102E5lIl].lIl102B8lIl[t]].lIl102AClIl[m]
                                    lIl101AFlIl[lIl101B2lIl].lIl102A6lIl = False
                                
                                if lIl101B0lIl[lIl101AFlIl[self.lIl102E5lIl].lIl102B8lIl[t]].lIl102ADlIl<2:
                                    break 
            

            
            for lIl101B9lIl in lIl101AFlIl:
                if lIl101B9lIl.lIl102B2lIl:
                    lIl101B9lIl.lIl102B2lIl = False
                    lIl101B9lIl.lIl102A6lIl = True
                    
                    
                    self.lIl10146lIl(lIl101AFlIl, lIl101B9lIl.lIl102BClIl, lIl101B9lIl.lIl102BDlIl)
            
        
            
            for lIl101B9lIl in lIl101AFlIl:
                if lIl101B9lIl.lIl102B2lIl:
                    lIl101B9lIl.lIl102A6lIl = True
                
                for lIl101B6lIl in lIl101B9lIl.lIl102BAlIl:
                    self.lIl1016ElIl(lIl101B1lIl[lIl101B6lIl], lIl101B9lIl, lIl101AFlIl)
                
                lIl101B9lIl.lIl102B0lIl = lIl101B9lIl.lIl102A6lIl 

                if lIl101B9lIl.lIl102B1lIl:
                    lIl101B9lIl.lIl102B1lIl = False

                if lIl101B9lIl.lIl102B2lIl:
                    lIl101B9lIl.lIl102B2lIl = False
                    self.lIl10146lIl(lIl101AFlIl, lIl101B9lIl.lIl102BClIl, lIl101B9lIl.lIl102BDlIl)

            
            self.lIl101A7lIl(False, lIl101B0lIl)
        
        except:
            pass
        finally:
            self.lIl102EElIl=False    

    


    def lIl101C2lIl(self,lIl101C3lIl, lIl101C4lIl, lIl101C5lIl, lIl101C6lIl):
        pass
        token='/'
        lIl101C7lIl=token+'mhj-software'+token+'grafcet'+token+self._mqtt1Topic1+self._mqtt1Topic2+token+'grafcetstudiomsg'+token+'#'
        lIl101C3lIl.subscribe(lIl101C7lIl)

    def lIl101C8lIl(self, lIl101C9lIl, lIl101CAlIl):
        lIl101CBlIl=lIl101E8lIl()
        lIl101CBlIl.lIl102CFlIl=lIl101CAlIl
        lIl101CBlIl.topic1=lIl101C9lIl
        self.lIl102F8lIl.append(lIl101CBlIl)
    
    def lIl101CClIl(self):
        if self.lIl102F8lIl.__len__()<=0: return
        lIl101CDlIl=self.lIl102F8lIl.pop(0)
        lIl101CElIl=lIl101CDlIl.topic1
        lIl101CFlIl=lIl101CDlIl.lIl102CFlIl

        if lIl101CElIl=="timestamp_grafcet":
            pass
            self.GrafcetEngineStatus.lIl102DElIl=lIl101CFlIl
            self.lIl10059lIl("TS1.bin",self.GrafcetEngineStatus.lIl102DElIl)

        if lIl101CElIl=="timestamp_interpreterData":
            pass
            self.GrafcetEngineStatus.lIl102DFlIl=lIl101CFlIl
            self.lIl10059lIl("TS2.bin",self.GrafcetEngineStatus.lIl102DFlIl)

        if lIl101CElIl=="io_settings":
                self.lIl102F9lIl.lIl10047lIl(lIl101CFlIl)
                self.lIl10059lIl("io_settings.bin",lIl101CFlIl)

        if lIl101CElIl=="grafcet_clear":
            if self.GrafcetEngineStatus.GrafcetRun==False:
                self.lIl100CBlIl(True)
                pass
            else:  
                pass
            
        if lIl101CElIl=="read_device_name":
            try:
                import platform
                pass
                device_name="MQTT@"+platform.uname()[1]
                self.lIl101DAlIl("device_name", device_name.encode())
            except:
                pass

        if lIl101CElIl=="grafcet_init":
            self.lIl102E8lIl=True
            pass
            
        if lIl101CElIl=="read_all_symbols":
            
            self.lIl100A3lIl(lIl101CFlIl)

        if lIl101CElIl=="write_symbol":
            self.lIl1009DlIl(lIl101CFlIl)
            
        if lIl101CElIl=="monitoring":
            lIl101D0lIl=str(lIl101CFlIl)
            if lIl101D0lIl.find("1")>=0:
                self.GrafcetEngineStatus.lIl102D9lIl=True
                pass
            else:
                self.GrafcetEngineStatus.lIl102D9lIl=False
                self.GrafcetEngineStatus.lIl102D4lIl=0
                pass
            
        if lIl101CElIl=="grafcet_run_stop":
            lIl101D0lIl=str(lIl101CFlIl)
            if lIl101D0lIl.find("1")>=0:
                self.GrafcetEngineStatus.GrafcetRun=True
                pass
            else:
                self.GrafcetEngineStatus.GrafcetRun=False
                pass
            
        if lIl101CElIl=="write_steps":
            self.lIl100B6lIl(lIl101CFlIl)
        
        if lIl101CElIl=="write_transitions":
            self.lIl100BClIl(lIl101CFlIl)           
        
        if lIl101CElIl=="write_actions":
            self.lIl100C2lIl(lIl101CFlIl)                 
        
        if lIl101CElIl=="write_interpreter":
            self.lIl100C8lIl(lIl101CFlIl)                   
    
    
    def lIl101D2lIl(self, lIl101D3lIl, lIl101D4lIl, lIl101D5lIl):
        lIl101D6lIl=lIl101D5lIl.topic.rfind('/')
        lIl101D7lIl=lIl101D5lIl.topic[lIl101D6lIl+1:]
        self.lIl101C8lIl(lIl101D7lIl, lIl101D5lIl.payload)

        '''
        if lIl101D7lIl=="timestamp_grafcet":
           pass
           self.GrafcetEngineStatus.lIl102DElIl=lIl101D5lIl.payload
           self.lIl10059lIl("TS1.bin",self.GrafcetEngineStatus.lIl102DElIl)

        if lIl101D7lIl=="timestamp_interpreterData":
           pass
           self.GrafcetEngineStatus.lIl102DFlIl=lIl101D5lIl.payload
           self.lIl10059lIl("TS2.bin",self.GrafcetEngineStatus.lIl102DFlIl)

        if lIl101D7lIl=="io_settings":
            self.lIl102F9lIl.lIl10047lIl(lIl101D5lIl.payload)
            self.lIl10059lIl("io_settings.bin",lIl101D5lIl.payload)

        if lIl101D7lIl=="grafcet_clear":
            if self.GrafcetEngineStatus.GrafcetRun==False:
                self.lIl100CBlIl(True)
                pass
            else:  
                pass
        
        if lIl101D7lIl=="read_device_name":
            try:
                import platform
                pass
                device_name="MQTT@"+platform.uname()[1]
                self.lIl101DAlIl("device_name", device_name.encode())
            except:
                pass

        if lIl101D7lIl=="grafcet_init":
           self.lIl102E8lIl=True
           pass
        
        if lIl101D7lIl=="read_all_symbols":
            
            self.lIl100A3lIl(lIl101D5lIl.payload)

        if lIl101D7lIl=="write_symbol":
            self.lIl1009DlIl(lIl101D5lIl.payload)
        
        if lIl101D7lIl=="monitoring":
            lIl101D8lIl=str(lIl101D5lIl.payload)
            if lIl101D8lIl.find("1")>=0:
                self.GrafcetEngineStatus.lIl102D9lIl=True
                pass
            else:
                self.GrafcetEngineStatus.lIl102D9lIl=False
                self.GrafcetEngineStatus.lIl102D4lIl=0
                pass
        
        if lIl101D7lIl=="grafcet_run_stop":
            lIl101D8lIl=str(lIl101D5lIl.payload)
            if lIl101D8lIl.find("1")>=0:
                self.GrafcetEngineStatus.GrafcetRun=True
                pass
            else:
                self.GrafcetEngineStatus.GrafcetRun=False
                pass
        
        if lIl101D7lIl=="write_steps":
            self.lIl100B6lIl(lIl101D5lIl.payload)
        
        if lIl101D7lIl=="write_transitions":
            self.lIl100BClIl(lIl101D5lIl.payload)           
        
        if lIl101D7lIl=="write_actions":
            self.lIl100C2lIl(lIl101D5lIl.payload)                 
        
        if lIl101D7lIl=="write_interpreter":
            self.lIl100C8lIl(lIl101D5lIl.payload)           
        '''
    def lIl101DAlIl(self, lIl101DBlIl, lIl101DClIl):
        token='/'
        lIl101DDlIl=token+'mhj-software'+token+'grafcet'+token+self._mqtt1Topic1+self._mqtt1Topic2+token+'grafcetenginemsg'+token+lIl101DBlIl
        self.lIl102E6lIl.publish(lIl101DDlIl, lIl101DClIl)

    def lIl101DElIl(self):
        self.lIl102E6lIl.disconnect()

#
